package modules;

import com.google.inject.AbstractModule;
import se.su.dsv.scipro.checklist.ChecklistCategoryRepo;
import se.su.dsv.scipro.checklist.ChecklistCategoryRepoImpl;
import se.su.dsv.scipro.checklist.ChecklistQuestionRepo;
import se.su.dsv.scipro.checklist.ChecklistQuestionRepoImpl;
import se.su.dsv.scipro.file.FileDescriptionRepo;
import se.su.dsv.scipro.file.FileDescriptionRepoImpl;
import se.su.dsv.scipro.finalseminar.FinalSeminarOppositionRepo;
import se.su.dsv.scipro.finalseminar.FinalSeminarOppositionRepoImpl;
import se.su.dsv.scipro.finalthesis.FinalThesisRepo;
import se.su.dsv.scipro.finalthesis.FinalThesisRepoImpl;
import se.su.dsv.scipro.milestones.MilestoneActivityTemplateRepository;
import se.su.dsv.scipro.milestones.MilestoneActivityTemplateRepositoryImpl;
import se.su.dsv.scipro.peer.*;
import se.su.dsv.scipro.plagiarism.TurnItInCheckRepo;
import se.su.dsv.scipro.plagiarism.TurnItInCheckRepoImpl;
import se.su.dsv.scipro.project.ProjectRepo;
import se.su.dsv.scipro.project.ProjectRepoImpl;
import se.su.dsv.scipro.report.GradingReportTemplateRepo;
import se.su.dsv.scipro.report.GradingReportTemplateRepoImpl;
import se.su.dsv.scipro.report.OppositionReportRepo;
import se.su.dsv.scipro.report.OppositionReportRepoImpl;
import se.su.dsv.scipro.system.*;

public class RepositoryModule extends AbstractModule {
    @Override
    protected void configure() {
        bind(ChecklistQuestionRepo.class).to(ChecklistQuestionRepoImpl.class);
        bind(FileDescriptionRepo.class).to(FileDescriptionRepoImpl.class);
        bind(FinalSeminarOppositionRepo.class).to(FinalSeminarOppositionRepoImpl.class);
        bind(GradingReportTemplateRepo.class).to(GradingReportTemplateRepoImpl.class);
        bind(MilestoneActivityTemplateRepository.class).to(MilestoneActivityTemplateRepositoryImpl.class);
        bind(OppositionReportRepo.class).to(OppositionReportRepoImpl.class);
        bind(PasswordRepo.class).to(PasswordRepoImpl.class);
        bind(ProjectRepo.class).to(ProjectRepoImpl.class);
        bind(UserRepo.class).to(UserRepoImpl.class);
        bind(TurnItInCheckRepo.class).to(TurnItInCheckRepoImpl.class);
        bind(PeerReviewRepository.class).to(PeerReviewRepositoryImpl.class);
        bind(PeerRequestRepository.class).to(PeerRequestRepositoryImpl.class);
        bind(ChecklistCategoryRepo.class).to(ChecklistCategoryRepoImpl.class);
        bind(CommentThreadRepo.class).to(CommentThreadRepoImpl.class);
        bind(FinalThesisRepo.class).to(FinalThesisRepoImpl.class);
        bind(FooterLinkRepo.class).to(FooterLinkRepoImpl.class);
        bind(FooterAddressRepo.class).to(FooterAddressRepoImpl.class);
    }
}