package se.su.dsv.scipro.file;

import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.GenericService;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

public interface FileDescriptionService extends GenericService<FileDescription, Long> {
    List<ProjectFile> latestUpload(Project project, int amount);
    FileDescription storeFile(FileUpload fileUpload);
    ProjectFile storeFile(ProjectFileUpload projectFileUpload, FileSource fileSource);
    Iterable<ProjectFile> getProjectFiles(Project project, Pageable pageable);
    Long countProjectFiles(Project project);
    InputStream getData(FileDescription attachment) throws IOException;
}
