package se.su.dsv.scipro.finalseminar;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.report.OppositionReport;
import se.su.dsv.scipro.system.ProjectType;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name="final_seminar_opposition")
@EqualsAndHashCode(of = {"project"}, callSuper = true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class FinalSeminarOpposition extends FinalSeminarParticipation {
    public static final int FEEDBACK_LENGTH = 2000;
    @ManyToOne(optional = false)
    @Getter
    private Project project;

    @OneToOne(optional = true, orphanRemoval = true, cascade = CascadeType.ALL)
    @Getter
    @Setter
    private FileDescription opponentReport;

    @OneToOne(optional = true, orphanRemoval = true, cascade = CascadeType.ALL, mappedBy = "finalSeminarOpposition")
    @Getter
    @Setter
    private OppositionReport oppositionReport;

    @Basic
    @Setter
    @Getter
    private Integer points;

    @Basic
    @Column(length = FEEDBACK_LENGTH)
    @Setter
    @Getter
    private String feedback;

    @Getter
    private Date dateReported;

    public void setDateReported(Date dateReported) {
        this.dateReported = dateReported != null ? new Date(dateReported.getTime()) : null;
    }

    @SuppressWarnings("UnusedDeclaration")
    public String getProjectTitle() {
        return project.getTitle();
    }

    public ProjectType getProjectType() {
        return getFinalSeminar().getProject().getProjectType();
    }

    public void setProject(final Project project) {
        this.project = project;
    }
}
