package se.su.dsv.scipro.finalseminar;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;

@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
@MappedSuperclass
@EqualsAndHashCode(of = {"user", "finalSeminar"}, callSuper = false)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public abstract class FinalSeminarParticipation extends DomainObject {

    @Id
    @GeneratedValue
    @Getter
    private Long id;

    @Getter
    @ManyToOne(optional = false)
    private User user;

    @Getter
    @ManyToOne(optional = false)
    private FinalSeminar finalSeminar;

    @Enumerated(EnumType.STRING)
    @Getter
    @Setter
    private FinalSeminarGrade grade = null;

    protected FinalSeminarParticipation(User user, FinalSeminar finalSeminar) {
        this.user = user;
        this.finalSeminar = finalSeminar;
    }

    protected FinalSeminarParticipation() {
    }

    public boolean isApproved() {
        return grade == FinalSeminarGrade.APPROVED;
    }

    public boolean hasGrade() {
        return (grade != null);
    }

    public void setUser(final User user) {
        this.user = user;
    }

    public void setFinalSeminar(final FinalSeminar finalSeminar) {
        this.finalSeminar = finalSeminar;
    }
}
