package se.su.dsv.scipro.finalseminar;

import se.su.dsv.scipro.system.AbstractServiceImpl;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.ArrayList;
import java.util.List;
import java.util.SortedSet;

import static com.mysema.query.support.Expressions.allOf;

@Named
public class FinalSeminarRespondentServiceImpl extends AbstractServiceImpl<FinalSeminarRespondent, Long> implements FinalSeminarRespondentService {

    @Inject
    public FinalSeminarRespondentServiceImpl(Provider<EntityManager> em) {
        super(em, FinalSeminarRespondent.class, QFinalSeminarRespondent.finalSeminarRespondent);
    }

    private FinalSeminarRespondent findOrCreate(User student, FinalSeminar finalSeminar) {
        FinalSeminarRespondent finalSeminarRespondent = findOne(allOf(
                QFinalSeminarRespondent.finalSeminarRespondent.user.eq(student),
                QFinalSeminarRespondent.finalSeminarRespondent.finalSeminar.eq(finalSeminar)));
        if (finalSeminarRespondent == null) {
            finalSeminarRespondent = new FinalSeminarRespondent(student, finalSeminar);
            return save(finalSeminarRespondent);
        }
        return finalSeminarRespondent;
    }

    @Override
    public List<FinalSeminarRespondent> findOrCreate(FinalSeminar finalSeminar) {
        if(finalSeminar.getId() == null) {
            return new ArrayList<>();
        }
        List<FinalSeminarRespondent> finalSeminarRespondents = new ArrayList<>();
        SortedSet<User> projectParticipants = finalSeminar.getProject().getProjectParticipants();
        for (User projectParticipant : projectParticipants) {
            finalSeminarRespondents.add(findOrCreate(projectParticipant, finalSeminar));
        }
        return finalSeminarRespondents;
    }
}
