package se.su.dsv.scipro.finalthesis;

import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.file.FileUpload;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.FilteredService;
import se.su.dsv.scipro.system.GenericService;

import java.io.Serializable;
import java.util.Date;

public interface FinalThesisService extends GenericService<FinalThesis, Long>,
        FilteredService<FinalThesis, Long, FinalThesisService.Filter> {
    FinalThesis upload(FileUpload fileUpload, Project project);

    boolean hasFinalThesis(Project project);
    FileDescription getFinalThesisFileDescription(Project project);
    void approve(Project project);
    void reject(Project project);
    boolean isUploadAllowed(Project project);
    FinalThesis findByProject(Project project);
    Date getRejectedDate(Project project);

    @Getter
    @Setter
    @SuppressWarnings("PMD.UnusedPrivateField")
    class Filter implements Serializable {

        private FinalThesis.Status status;

    }
}
