package se.su.dsv.scipro.forum;

import com.google.inject.persist.Transactional;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.querydsl.QueryDslPredicateExecutor;
import se.su.dsv.scipro.forum.dataobjects.ForumPost;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.project.Project;

import java.util.List;

@Transactional
interface ForumPostRepository extends JpaRepository<ForumPost, Long>, QueryDslPredicateExecutor<ForumPost> {

    List<ForumPost> findByThread(ForumThread forumThread);

    List<ForumPost> latestPost(Project project, int amount);
}
