package se.su.dsv.scipro.forum;

import se.su.dsv.scipro.forum.dataobjects.ProjectThread;
import se.su.dsv.scipro.forum.dataobjects.QProjectThread;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.GenericRepo;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.List;

class ProjectThreadRepositoryImpl extends GenericRepo<ProjectThread, Long> implements ProjectThreadRepository {
    @Inject
    ProjectThreadRepositoryImpl(Provider<EntityManager> em) {
        super(em, ProjectThread.class, QProjectThread.projectThread);
    }

    @Override
    public List<ProjectThread> findByProject(Project project) {
        return findAll(QProjectThread.projectThread.project.eq(project));
    }

}
