package se.su.dsv.scipro.forum.notifications;

import com.mysema.query.jpa.impl.JPAQuery;
import scala.Option;
import se.su.dsv.scipro.forum.dataobjects.ForumPost;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

class ForumNotificationRepositoryImpl implements ForumNotificationRepository {
    private final Provider<EntityManager> entityManagerProvider;

    @Inject
    ForumNotificationRepositoryImpl(final Provider<EntityManager> entityManagerProvider) {
        this.entityManagerProvider = entityManagerProvider;
    }

    @Override
    public Option<ForumNotification> findByForumPost(final ForumPost forumPost) {
        return Option.apply(new JPAQuery(entityManagerProvider.get())
                .from(QForumNotification.forumNotification)
                .where(QForumNotification.forumNotification.forumPost.eq(forumPost))
                .uniqueResult(QForumNotification.forumNotification));
    }

    @Override
    public void save(ForumNotification forumNotification) {
        entityManagerProvider.get().persist(forumNotification);
    }
}
