package se.su.dsv.scipro.forummail;

import com.google.inject.persist.Transactional;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

public class ForumMailSettingsServiceImpl extends AbstractServiceImpl<ForumMailSettings,Long> implements ForumMailSettingsService {

    public static final long INSTANCE_ID = 1L;

    @Inject
    public ForumMailSettingsServiceImpl(Provider<EntityManager> em) {
        super(em, ForumMailSettings.class, QForumMailSettings.forumMailSettings);
    }

    @Override
    @Transactional
    public ForumMailSettings getSettings() {
        ForumMailSettings settings = findOne(INSTANCE_ID);
        if (settings == null) {
            settings = new ForumMailSettings(INSTANCE_ID);
            save(settings);
        }
        return settings;
    }
}
