package se.su.dsv.scipro.forummail;

import se.su.dsv.scipro.system.Lifecycle;
import se.su.dsv.scipro.workerthreads.Scheduler;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.inject.Singleton;
import java.util.concurrent.TimeUnit;

@Singleton
class ForumMailWorkerSchedule implements Lifecycle {
    private final Scheduler scheduler;
    private final Provider<ForumMailWorker> forumMailWorker;

    @Inject
    ForumMailWorkerSchedule(final Scheduler scheduler, final Provider<ForumMailWorker> forumMailWorker) {
        this.scheduler = scheduler;
        this.forumMailWorker = forumMailWorker;
    }

    @Override
    public void start() {
        scheduler.schedule("Forum mail worker").runBy(forumMailWorker).every(10, TimeUnit.MINUTES);
    }

    @Override
    public void stop() {

    }
}
