package se.su.dsv.scipro.integration.activityforum;

import lombok.AccessLevel;
import lombok.Data;
import lombok.Setter;
import se.su.dsv.scipro.activityplan.Activity;
import se.su.dsv.scipro.forum.dataobjects.ProjectThread;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Setter(AccessLevel.NONE)
@Entity
@Table(name = "activity_thread")
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
class ActivityThread {
    @EmbeddedId
    private Id id = new Id();

    @ManyToOne
    @MapsId("threadId")
    @JoinColumn(name = "project_thread_id")
    private ProjectThread thread;

    @ManyToOne
    @MapsId("activityId")
    private Activity activity;

    protected ActivityThread() {
        // JPA
    }

    public ActivityThread(final ProjectThread projectThread, final Activity activity) {
        this.thread = projectThread;
        this.activity = activity;
    }

    @Data
    @Embeddable
    static class Id implements Serializable {
        @Basic
        private Long threadId;
        @Basic
        private Long activityId;
    }
}
