package se.su.dsv.scipro.mail;

import org.slf4j.Logger;
import se.su.dsv.scipro.file.FileDescription;

import javax.mail.MessagingException;
import java.util.Arrays;
import java.util.UUID;

class PrintingMailer implements Mailer {
    @Override
    public MailResult mail(final String fromName, final String fromEmail, final String[] recipients, final String subject, final String message, final FileDescription attachment) throws MessagingException {
        return new MailResult() {
            final String messageID = UUID.randomUUID().toString();

            @Override
            public String getMessageID() {
                return messageID;
            }

            @Override
            public void log(Logger logger) {
                logger.info("Sending email...");
                logger.info("From: {} <{}>", fromName, fromEmail);
                logger.info("To: {}", Arrays.toString(recipients));
                logger.info("Subject: {}", subject);
                logger.info("Message:");
                logger.info(message);
            }
        };
    }
}
