package se.su.dsv.scipro.match;

import se.su.dsv.scipro.reusable.SciProUtilities;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;

public class ApplicationPeriodFacadeImpl implements ApplicationPeriodFacade {

    @Inject
    private IdeaService ideaService;

    @Override
    public int totalTargets(ApplicationPeriod ap, ProjectType projectType) {
        int total = 0;
        for (Target t : ap.getTargets()) {
            if (t.getProjectType().equals(projectType)) {
                total = total + t.getTarget();
            }
        }
        return total;
    }

    @Override
    public int remainingTargets(ApplicationPeriod ap, ProjectType projectType) {
        Long total = 0L;
        for (Target t : ap.getTargets()) {
            if (t.getProjectType().equals(projectType)) {
                User e = t.getUser();
                total += ideaService.countMatched(ap, e, projectType);
            }
        }
        return totalTargets(ap, projectType) - SciProUtilities.safeLongToInt(total);
    }

}