package se.su.dsv.scipro.match;

import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.activityplan.ActivityPlanTemplate;
import se.su.dsv.scipro.system.ProjectType;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.MapsId;
import java.io.Serializable;

@Getter
@Entity
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class ApplicationPeriodProjectType implements Serializable {
    @EmbeddedId
    private ApplicationPeriodProjectTypeId applicationPeriodProjectTypeId = new ApplicationPeriodProjectTypeId();

    @MapsId("applicationPeriodId")
    @ManyToOne
    private ApplicationPeriod applicationPeriod;

    @MapsId("projectTypeId")
    @ManyToOne
    private ProjectType projectType;

    @ManyToOne(optional = true)
    @Setter
    private ActivityPlanTemplate activityPlanTemplate;

    protected ApplicationPeriodProjectType() {}

    public ApplicationPeriodProjectType(ApplicationPeriod applicationPeriod, ProjectType projectType) {
        this.applicationPeriod = applicationPeriod;
        this.projectType = projectType;
    }

    public ProjectType getProjectType() {
        return projectType;
    }

    public ActivityPlanTemplate getActivityPlanTemplate() {
        return activityPlanTemplate;
    }
}