package se.su.dsv.scipro.match;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@Data
@EqualsAndHashCode(callSuper = false)
@Entity
@Table(name = "idea_export")
@ToString(exclude = {"idea"})
@SuppressWarnings("PMD.UnusedPrivateField")
public class IdeaExport extends DomainObject {

    public enum Result { FAIL, SUCCESS }

    @Id
    @GeneratedValue
    private Long id;

    @Enumerated(EnumType.STRING)
    private Result result;

    @Basic
    private String reason;

    @OneToOne
    private Idea idea;

    public boolean wasSuccessful() {
        return result.equals(Result.SUCCESS);
    }
}
