package se.su.dsv.scipro.match;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.Program;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

@Data
@Entity
@Table(name = "idea_student")
@AssociationOverrides({
		@AssociationOverride(name = "idea",
			joinColumns = @JoinColumn(name = "idea_id")) })
@EqualsAndHashCode(of = {"user", "idea"})
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class IdeaParticipation implements Serializable {
	protected IdeaParticipation() {
		
	}
	
	public IdeaParticipation(User student, Idea idea) {
		this.user = student;
		this.setIdea(idea);
	}

    @Id
    @GeneratedValue
    private Long id;

    @ManyToOne
    private User user;

    @ManyToOne
    private Idea idea;

	@NotNull
    private Date dateCreated = new Date();

    @ManyToOne(optional = true)
    private Program program;
}
