package se.su.dsv.scipro.match;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.LazyDeletableDomainObject;
import se.su.dsv.scipro.system.ResearchArea;

import javax.persistence.*;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Set;

@Entity
@Cacheable(true)
@Data
@EqualsAndHashCode(of = {"keyword", "id"}, callSuper = true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class Keyword extends LazyDeletableDomainObject {
    public static final Comparator<Keyword> ALPHABETIC_ORDER = new Comparator<Keyword>() {
        @Override
        public int compare(Keyword keyword, Keyword keyword1) {
            return keyword.getKeyword().compareToIgnoreCase(keyword1.getKeyword());
        }
    };

    @Id
    @GeneratedValue
    private Long id;

    private String keyword;

    @ManyToMany(fetch = FetchType.EAGER,targetEntity=ResearchArea.class)
	@JoinTable(name="Keyword_researcharea")
    private Set<ResearchArea> researchAreas = new HashSet<>();

    public Keyword() {
    }

    public Keyword(String keyword) {
        this.keyword = keyword;
    }

    public void addResearchArea(ResearchArea area) {
    	this.researchAreas.add(area);
    }

    public void removeResearchArea(ResearchArea area) {
    	this.researchAreas.remove(area);
    }
}
