package se.su.dsv.scipro.match;

import com.google.inject.AbstractModule;
import com.google.inject.multibindings.Multibinder;

public class MatchModule extends AbstractModule {
    @Override
    protected void configure() {
        Multibinder.newSetBinder(binder(), IdeaCreationJudge.class);
        bind(ProjectStartNotifier.class).asEagerSingleton();
        bind(AddActivityPlanOnProjectStart.class).asEagerSingleton();
        bind(ApplicationPeriodService.class).to(ApplicationPeriodServiceImpl.class);
        bind(IdeaService.class).to(IdeaServiceImpl.class);
        bind(FirstMeetingRepository.class).to(FirstMeetingRepositoryImpl.class);
        bind(KeywordService.class).to(KeywordServiceImpl.class);
        bind(MatchService.class).to(MatchServiceImpl.class);
        bind(ProgramService.class).to(ProgramServiceImpl.class);
        bind(MatchFollowUpService.class).to(MatchFollowUpServiceImpl.class);
        bind(TargetService.class).to(TargetServiceImpl.class);
        bind(ApplicationPeriodProjectTypeService.class).to(ApplicationPeriodProjectTypeServiceImpl.class);
    }
}
