package se.su.dsv.scipro.match;

import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

public class MatchServiceImpl extends AbstractServiceImpl<Match,Long> implements MatchService {
    @Inject
    public MatchServiceImpl(Provider<EntityManager> em) {
        super(em, Match.class, QMatch.match);
    }

    @Override
    public Iterable<Match> getMatchHistory(Idea idea, Pageable pageable) {
        return findAll(QMatch.match.idea.eq(idea), pageable);
    }

    @Override
    public Long countMatchHistory(Idea idea) {
        return count(QMatch.match.idea.eq(idea));
    }

}
