package se.su.dsv.scipro.match;

import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Collection;
import java.util.Set;

public interface TargetService extends GenericService<Target, TargetId> {
    Target findOne(ApplicationPeriod applicationPeriod, User supervisor, ProjectType projectType);
    boolean hasTargetsLeft(ApplicationPeriod applicationPeriod, User supervisor);
    boolean hasTargetsLeft(ApplicationPeriod applicationPeriod, User supervisor, ProjectType projectType);
    Set<ProjectType> projectTypesWithTargetsLeft(ApplicationPeriod applicationPeriod, User supervisor);
    int ideasLeftToCreateToMeetTarget(ApplicationPeriod ap, User e, ProjectType pc);

    @Getter
    @Setter
    @SuppressWarnings({"PMD.UnusedPrivateField", "UnusedDeclaration"})
    class FilterParams implements Serializable {
        private Collection<ProjectType> projectTypes;
        private User supervisor;
        private ApplicationPeriod applicationPeriod;
    }
}