package se.su.dsv.scipro.match;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import java.io.Serializable;

@Embeddable
@EqualsAndHashCode
@Getter
@Setter
public class Watson implements Serializable {

    public static final int MAX_CHARS = 300;
    public static final int WATSON_LENGTH = 1024;

    @Column(nullable = true, length = WATSON_LENGTH)
    private String what = "";

    @Column(nullable = true, length = WATSON_LENGTH)
    private String why = "";

    @Column(nullable = true, length = WATSON_LENGTH)
    private String theoryHow = "";

    @Column(nullable = true, length = WATSON_LENGTH)
    private String practicalHow = "";

    public Watson() {
    }

    Watson(Watson original) {
        this.what = original.what;
        this.why = original.why;
        this.theoryHow = original.theoryHow;
        this.practicalHow = original.practicalHow;
    }

    @Override
    public String toString() {
        return "Watson [what=" + what + ", why=" + why + ", theoryHow="
            + theoryHow + ", practicalHow=" + practicalHow + "]";
    }
}
