package se.su.dsv.scipro.milestones;

import com.google.inject.persist.Transactional;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.querydsl.QueryDslPredicateExecutor;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.milestones.dataobjects.MilestonePhaseTemplate;
import se.su.dsv.scipro.system.ProjectType;

import java.util.Collection;
import java.util.Date;
import java.util.List;

@Transactional
public interface MilestoneActivityTemplateRepository extends JpaRepository<MilestoneActivityTemplate, Long>, QueryDslPredicateExecutor<MilestoneActivityTemplate> {

    List<MilestoneActivityTemplate> findActivities(MilestoneActivityTemplate.Type type, ProjectType projectType, Date projectStartDate);

    List<MilestoneActivityTemplate> findAllActivitiesByProjectType(MilestoneActivityTemplate.Type type, Collection<ProjectType> projectType);

    List<MilestoneActivityTemplate> findAllActivitiesInOrder(MilestoneActivityTemplate.Type type, ProjectType projectType, Date projectStartDate);

    List<MilestoneActivityTemplate> findByMilestonePhase(MilestonePhaseTemplate milestonePhaseTemplate);

    List<MilestoneActivityTemplate> findActiveByPhase(MilestonePhaseTemplate milestonePhaseTemplate, ProjectType projectType, Date projectStartDate);

    long countByMilestonePhase(MilestonePhaseTemplate milestonePhaseTemplate);

    long countActivities(MilestoneActivityTemplate.Type type, ProjectType projectType, Date projectStartDate);

    long countActivities(ProjectType projectType, Date projectStartDate);

    MilestoneActivityTemplate findBySortOrderAndMilestonePhaseTemplate(int sortOrder, MilestonePhaseTemplate milestonePhaseTemplate);
}
