package se.su.dsv.scipro.milestones.dataobjects;

import lombok.Getter;
import se.su.dsv.scipro.data.dataobjects.Member;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.util.Collections;
import java.util.List;

@Entity
@Table(name = "milestone")
public class Milestone extends DomainObject {

    @Id
    @GeneratedValue
    protected long id;

    @ManyToOne
    private Project project;

    @ManyToOne(optional = true)
    @Getter
    private User user;

    @ManyToOne(optional = false)
    private MilestoneActivityTemplate activity;

    @Column(name = "confirmed", nullable = false)
    private boolean confirmed = false;

    @Override
    public Long getId() {
        return id;
    }

    protected Milestone() {

    }

    public Milestone(Project project, MilestoneActivityTemplate activity) {
        this.project = project;
        this.activity = activity;
    }

    public Milestone(Project project, User student, MilestoneActivityTemplate activity) {
        this.project = project;
        this.user = student;
        this.activity = activity;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public boolean isConfirmed() {
        return confirmed;
    }

    public void setConfirmed(boolean confirmed) {
        this.confirmed = confirmed;
    }

    public Project getProject() {
        return project;
    }

    public void setProject(Project project) {
        this.project = project;
    }

    public MilestoneActivityTemplate getActivity() {
        return activity;
    }

    public void setActivity(MilestoneActivityTemplate activity) {
        this.activity = activity;
    }

    public List<Member> getMembers() {
        return Collections.singletonList(new Member(user, Member.Type.MILESTONE_INDIVIDUAL));
    }
}
