package se.su.dsv.scipro.milestones.dataobjects;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.LazyDeletableDomainObject;

import javax.persistence.*;

@Data
@Entity
@Table(name = "milestone_phase_template")
@EqualsAndHashCode(callSuper = false)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class MilestonePhaseTemplate extends LazyDeletableDomainObject {
    @Id
    @GeneratedValue
    protected long id;

    @Override
    public Long getId() {
        return id;
    }

    @Basic(optional = false)
    private String title;

    @Basic(optional = true)
    private String description;

    @Column(name = "sortOrder")
    private int sortOrder;

    public MilestonePhaseTemplate() {

    }

    public MilestonePhaseTemplate(String title, String description) {
        this.title = title;
        this.description = description;
    }

    public MilestonePhaseTemplate(String title, String description, int sortOrder) {
        this.title = title;
        this.description = description;
        this.sortOrder = sortOrder;
    }

    @Override
    public String toString() {
        return title;
    }
}
