package se.su.dsv.scipro.milestones.service;


import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.milestones.dataobjects.MilestonePhaseTemplate;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.springdata.SortOrderService;
import se.su.dsv.scipro.system.ProjectType;

import java.util.Collection;
import java.util.Date;
import java.util.List;

public interface MilestoneActivityTemplateService extends SortOrderService<MilestoneActivityTemplate> {

    List<MilestoneActivityTemplate> findAll();

    List<MilestoneActivityTemplate> getActivities(MilestoneActivityTemplate.Type type, ProjectType projectType, Date projectStartDate);

    List<MilestoneActivityTemplate> getAllActivities(MilestoneActivityTemplate.Type type, Collection<ProjectType> projectTypes);

    List<MilestoneActivityTemplate> findByMileStonePhase(MilestonePhaseTemplate milestonePhaseTemplate);

    List<MilestoneActivityTemplate> findActiveByPhase(MilestonePhaseTemplate milestonePhaseTemplate, Project project);

    List<MilestoneActivityTemplate> getActivitiesInOrder(MilestoneActivityTemplate.Type type, Project project);

    Long countActivities(MilestoneActivityTemplate.Type type, ProjectType projectType, Date projectStartDate);


    MilestoneActivityTemplate save(MilestoneActivityTemplate activity, MilestonePhaseTemplate currentPhase);

    long countActivities(ProjectType projectType, Date projectStartDate);

    MilestoneActivityTemplate findByEvent(String eventName);
}
