package se.su.dsv.scipro.notes;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;

@Data
@EqualsAndHashCode(callSuper = false, of = "id")
@Entity
@Table(name = "note")
@Cacheable(true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class Note extends DomainObject {

    @Id
    @GeneratedValue
    private Long id;

    @OneToOne(optional = false, targetEntity = User.class)
    private User user;

    @Lob
    @Column(name = "content", nullable = true)
    private String content = "";

}
