package se.su.dsv.scipro.notifications;

import com.google.inject.PrivateModule;
import se.su.dsv.scipro.notifications.interfaces.NotificationMailFormatter;
import se.su.dsv.scipro.notifications.interfaces.impl.NotificationMailFormatterImpl;

public class NotificationModule extends PrivateModule {

    public static final String NOTIFICATION_RELATIVE_PAGE_URL = "notification";

    @Override
    protected void configure() {
        bind(Notifications.class).asEagerSingleton();

        bind(NotificationService.class).to(NotificationServiceImpl.class);
        expose(NotificationService.class);

        bind(NotificationEventRepository.class).to(NotificationEventRepositoryImpl.class);
        bind(NotificationEventService.class).to(NotificationEventServiceImpl.class);
        expose(NotificationEventService.class);

        bind(NotificationMailFormatter.class).to(NotificationMailFormatterImpl.class);
        expose(NotificationMailFormatter.class);
        bind(NotificationController.class).to(NotificationControllerImpl.class);
        expose(NotificationController.class);
    }

}
