package se.su.dsv.scipro.notifications;

import lombok.Data;
import se.su.dsv.scipro.notifications.dataobject.Notification;
import se.su.dsv.scipro.notifications.dataobject.NotificationEvent;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.FilteredService;
import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

public interface NotificationService extends GenericService<Notification, Long>, FilteredService<Notification, Long, NotificationService.Filter> {

    long countUnread(User user);
    void markRead(User user);
    void setRead(User user, NotificationEvent notificationEvent, boolean read);
    void setRead(Project project, boolean read);
    Collection<Notification> findUnreadByUsers(List<User> users);
    void deleteAllForUser(User user);

    @Data
    @SuppressWarnings("PMD.UnusedPrivateField")
    class Filter implements Serializable {
        private User currentUser;
        private User fromUser;
    }
}
