package se.su.dsv.scipro.notifications.dataobject;

import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.ManyToOne;

@Entity
public class IdeaEvent extends NotificationEvent {


    public enum Event {
        STATUS_CHANGE, PARTNER_ACCEPT,
        ADDED_AS_PARTNER, FIRST_MEETING, EXPORTED_FAIL
    }

    @ManyToOne
    private Idea idea;

    @Enumerated(EnumType.STRING)
    private Event event;

    public IdeaEvent() {
        super(Notification.Type.IDEA);
    }

    public Idea getIdea() {
        return idea;
    }

    public void setIdea(Idea idea) {
        this.idea = idea;
    }

    @Override
    public Event getEvent() {
        return event;
    }

    public void setEvent(Event event) {
        this.event = event;
    }

    @Override
    public String getEntityTitle() {
        return idea.getTitle();
    }

    @Override
    public boolean hasEntity() {
        return idea != null;
    }

    @Override
    public DomainObject getEntity() {
        return idea;
    }
}
