package se.su.dsv.scipro.notifications.dataobject;

import se.su.dsv.scipro.peer.PeerReview;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.ManyToOne;

@Entity
public class PeerEvent extends NotificationEvent {

    public enum Event { REVIEW_COMPLETED, REVIEW_COMMENT, REVIEW_ACCEPTED, REQUEST_DELETED,
        REQUEST_EXPIRED }

    @ManyToOne
    private PeerReview review;

    @Enumerated(EnumType.STRING)
    private Event event;

    public PeerEvent() {
        super(Notification.Type.PEER);
    }

    @Override
    public Project getProject() {
        return review.getProject();
    }

    public PeerReview getReview() {
        return review;
    }

    public void setReview(PeerReview review) {
        this.review = review;
    }

    @Override
    public Event getEvent() {
        return event;
    }

    public void setEvent(Event event) {
        this.event = event;
    }

    @Override
    public String getEntityTitle() {
        return review.getProject().getTitle();
    }

    @Override
    public boolean hasEntity() {
        return review != null;
    }

    @Override
    public DomainObject getEntity() {
        return review;
    }
}
