package se.su.dsv.scipro.notifications.dataobject;

import se.su.dsv.scipro.finalseminar.FinalSeminar;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.ManyToOne;

@Entity
public class SeminarEvent extends NotificationEvent {

    public enum Event { CREATED, ROOM_CHANGED, DATE_CHANGED, OPPOSITION_CHANGED, PARTICIPATION_CHANGED, THESIS_UPLOADED, THESIS_UPLOADED_OPPONENT,
                        OPPOSITION_REPORT_UPLOADED, THESIS_DELETED, THESIS_UPLOAD_REMIND, CANCELLED}

    @ManyToOne
    private FinalSeminar seminar;

    @Enumerated(EnumType.STRING)
    private Event event;

    public SeminarEvent() {
        super(Notification.Type.FINAL_SEMINAR);
    }

    public FinalSeminar getSeminar() {
        return seminar;
    }

    public void setSeminar(FinalSeminar seminar) {
        this.seminar = seminar;
    }

    @Override
    public Event getEvent() {
        return event;
    }

    public void setEvent(Event event) {
        this.event = event;
    }

    @Override
    public String getEntityTitle() {
        return seminar.getProject().getTitle();
    }

    @Override
    public boolean hasEntity() {
        return seminar != null;
    }

    @Override
    public Project getProject() {
        return seminar != null ? seminar.getProject() : null;
    }

    @Override
    public DomainObject getEntity() {
        return seminar;
    }
}
