package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.match.IdeaParticipation;
import se.su.dsv.scipro.notifications.dataobject.IdeaEvent;
import se.su.dsv.scipro.system.User;

import java.text.MessageFormat;

public class IdeaEventFormatter extends AbstractEventFormatter<IdeaEvent> {

    IdeaEventFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(IdeaEvent event) {
        Idea idea = event.getIdea();

        String title = idea.getTitle();
        String level = idea.getProjectType().getName();
        String authors = formatUserList(idea.getIdeaParticipations(), new UserConverter<IdeaParticipation>() {
            @Override
            public User toUser(IdeaParticipation object) {
                return object.getUser();
            }
        });
        String status = String.valueOf(idea.getMatchStatus());

        User supervisorEmployee = idea.getMatch().getSupervisor();
        String supervisor = supervisorEmployee != null ? formatUser(supervisorEmployee) : "";

        String format = getProperty(event.getType().name());
        return MessageFormat.format(format,
                title,
                level,
                authors,
                status,
                supervisor);
    }
}
