package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.notifications.dataobject.ProjectEvent;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;

import java.text.MessageFormat;

class ProjectEventFormatter extends AbstractEventFormatter<ProjectEvent> {

    ProjectEventFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(ProjectEvent event) {
        Project project = event.getProject();

        String title = project.getTitle();
        String level = project.getProjectType().getName();

        String supervisor = formatUser(project.getHeadSupervisor());

        String authors = formatUserList(project.getProjectParticipants(), new UserConverter<User>() {
            @Override
            public User toUser(User object) {
                return object;
            }
        });

        String coSupervisors = formatUserList(project.getCoSupervisors(), new UserConverter<User>() {
            @Override
            public User toUser(User object) {
                return object;
            }
        });

        String reviewers = formatUserList(project.getReviewers(), new UserConverter<User>() {
            @Override
            public User toUser(User object) {
                return object;
            }
        });

        String format = getProperty(event.getType().name());
        return MessageFormat.format(format,
                title,
                level,
                authors,
                supervisor,
                coSupervisors,
                reviewers);
    }
}
