package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.notifications.dataobject.ProjectForumEvent;
import se.su.dsv.scipro.project.Project;

import java.text.MessageFormat;

public class ProjectForumEventFormatter extends AbstractEventFormatter<ProjectForumEvent> {

    public ProjectForumEventFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(ProjectForumEvent event) {
        Project project = event.getProject();

        String projectTitle = "";
        if (project != null) {
            projectTitle = project.getTitle();
        }

        String format = getProperty(event.getType().name());
        return MessageFormat.format(format,
                projectTitle);
    }
}
