package se.su.dsv.scipro.notifications.settings.entities;

import se.su.dsv.scipro.notifications.dataobject.Notification;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;

@Entity
@Table(name = "notification_delivery_configuration",
       uniqueConstraints = {
               @UniqueConstraint(name = "one_setting_per_user", columnNames = {"type", "event", "method", "user_id"})
       })
public class DeliveryConfiguration extends Configuration {

    @Column(name = "method", nullable = false)
    @Enumerated(EnumType.STRING)
    private DeliveryMethod method;

    @Column(name = "enabled", nullable = false)
    private boolean enabled = true;

    @ManyToOne(optional = true)
    @JoinColumn(nullable = true, name = "user_id")
    private User user;

    public DeliveryConfiguration() {
    }

    public DeliveryConfiguration(Notification.Type type, String event, DeliveryMethod method, User user) {
        super(type, event);
        this.method = method;
        this.user = user;
    }

    public DeliveryMethod getMethod() {
        return method;
    }

    public void setMethod(DeliveryMethod method) {
        this.method = method;
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

}
