package se.su.dsv.scipro.notifications.settings.entities;

import se.su.dsv.scipro.data.dataobjects.Member;
import se.su.dsv.scipro.notifications.dataobject.Notification;

import javax.persistence.*;

@Entity
@Table(name = "notification_receiver_configuration",
        uniqueConstraints = {
                @UniqueConstraint(name = "one_setting_per_role", columnNames = {"type", "event", "member"})
        }
)
public class ReceiverConfiguration extends Configuration {

    @Column(name = "member", nullable = false)
    @Enumerated(EnumType.STRING)
    private Member.Type member;

    @Column(name = "enabled", nullable = false)
    private boolean enabled = false;

    public ReceiverConfiguration() {

    }

    public ReceiverConfiguration(Notification.Type group, Enum event, Member.Type member) {
        super(group, event.name());
        this.member = member;
    }

    public Member.Type getMember() {
        return member;
    }

    public void setMember(Member.Type member) {
        this.member = member;
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }
}
