package se.su.dsv.scipro.phd;

import se.su.dsv.scipro.system.AbstractServiceImpl;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.Date;
import java.util.List;

public class DepartmentServiceServiceImpl extends AbstractServiceImpl<DepartmentService, Long> implements DepartmentServiceService {

    @Inject
    public DepartmentServiceServiceImpl(Provider<EntityManager> em) {
        super(em, DepartmentService.class, QDepartmentService.departmentService);
    }

    @Override
    public List<DepartmentService> getCurrent(User user) {
        QDepartmentService department = QDepartmentService.departmentService;
        return from(department).where(department.user.eq(user).and((department.dateEnded.after(new Date()))))
                .orderBy(department.dateEnded.desc()).list(department);
    }

    @Override
    public List<DepartmentService> getPrevious(User user) {
        QDepartmentService department = QDepartmentService.departmentService;
        return from(department).where(department.user.eq(user).and((department.dateEnded.before(new Date()))))
                .orderBy(department.dateEnded.desc()).list(department);
    }
}
