package se.su.dsv.scipro.plagiarism;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Entity
@Cacheable(true)
@Data
@EqualsAndHashCode(callSuper = true)
@SuppressWarnings("PMD.UnusedPrivateField")
public class TurnitinSettings extends DomainObject {

    public static final int KILO = 1024;

    @Id
    private Long id = null;

    @Override
    public Long getId() {
        return id;
    }

    @Basic(optional = false)
    private String username = "";

    @Basic(optional = false)
    private String password = "";

    @Basic(optional = false)
    private String firstName = "";

    @Basic(optional = false)
    private String lastName = "";

    @Basic(optional = false)
    private int classNo;

    @Basic(optional = false)
    private String className = "";

    @Basic(optional = false)
    private String assignmentName = "";

    @Basic(optional = false)
    private String sharedKey = "";

    @Basic(optional = false)
    private int accountNo;

    @Basic(optional = true)
    private Date expirationDate;

    @Basic(optional = true)
    private Date lastFailedDate;

    @Basic(optional = false)
    private int maxFileSize = 20;

    @ElementCollection
    @CollectionTable
    @Column
    private List<String> expirationMails = new ArrayList<>();

    @Basic(optional = true)
    @Lob
    private String expirationContent;

    @Basic(optional = false)
    private boolean enabled = false;

    @Column(name = "integrationId")
    @Basic(optional = false)
    private int integrationId;

    @Basic(optional = false)
    private String integrationURL = "";

    public TurnitinSettings() {
    }

    public TurnitinSettings(final Long id) {
        this.id = id;
    }

    public int getMaxFileSizeInBytes() {
        return maxFileSize * KILO * KILO;
    }
}
