package se.su.dsv.scipro.project;

import se.su.dsv.scipro.system.GenericRepo;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;
import java.util.Collection;
import java.util.List;

public class ProjectRepoImpl extends GenericRepo<Project, Long> implements ProjectRepo {
    @Inject
    public ProjectRepoImpl(Provider<EntityManager> em) {
        super(em, Project.class, QProject.project);
    }

    @Override
    public List<User> findMultipleAuthors(Collection<Project> projects) {
        TypedQuery<User> query = em().createQuery("select distinct participant " +
                "from Project project " +
                "join project.projectParticipants as participant " +
                "where project in :projects " +
                "group by participant " +
                "having count(participant) > 1", User.class);
        query.setParameter("projects", projects);
        return query.getResultList();
    }
}
