package se.su.dsv.scipro.report;

import lombok.EqualsAndHashCode;
import lombok.ToString;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Comparator;

@ToString
@EqualsAndHashCode(callSuper = true)
@MappedSuperclass
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public abstract class AbstractCriterion extends DomainObject {
    @Id
    @GeneratedValue
    private Long id;

    @Basic(optional = false)
    private String title;

    @Basic(optional = false)
    private Integer sortOrder;

    protected AbstractCriterion() {
    }

    protected AbstractCriterion(String title, int sortOrder) {
        this.title = title;
        this.sortOrder = sortOrder;
    }

    public Long getId() {
        return this.id;
    }

    public String getTitle() {
        return this.title;
    }

    public Integer getSortOrder() {
        return this.sortOrder;
    }

    public static class BySortOrderComparator implements Comparator<AbstractCriterion>, Serializable {
        @Override
        public int compare(AbstractCriterion o1, AbstractCriterion o2) {
            return o1.sortOrder.compareTo(o2.sortOrder);
        }
    }
}
