package se.su.dsv.scipro.report;

import se.su.dsv.scipro.system.GenericRepo;
import se.su.dsv.scipro.system.ProjectType;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;

public class GradingReportTemplateRepoImpl extends GenericRepo<GradingReportTemplate, Long> implements GradingReportTemplateRepo {
    @Inject
    public GradingReportTemplateRepoImpl(Provider<EntityManager> em) {
        super(em, GradingReportTemplate.class, QGradingReportTemplate.gradingReportTemplate);
    }

    @Override
    public GradingReportTemplate findByProjectTypeAndCredits(ProjectType projectType, int credits) {
        TypedQuery<GradingReportTemplate> query = em().createQuery("select distinct template from GradingReportTemplate template where template.projectType = :projectType and template.credits = :credits", GradingReportTemplate.class);
        query.setParameter("projectType", projectType);
        query.setParameter("credits", credits);
        return query.getSingleResult();
    }
}