package se.su.dsv.scipro.report;

import se.su.dsv.scipro.project.Project;

import javax.persistence.Entity;

@Entity
public class ReviewerGradingReport extends GradingReport {

    protected ReviewerGradingReport() {
    }

    ReviewerGradingReport(Project project) {
        super(project);
    }

    public boolean isFinished() {
        return allCriteriaAssessed();
    }

    private boolean allCriteriaAssessed() {
        for (GradingCriterion gradingCriterion : getGradingCriteria()) {
            if (!gradingCriterion.isAssessed()) {
                return false;
            }
        }
        return true;
    }
}