package se.su.dsv.scipro.reviewing;

import com.google.common.eventbus.EventBus;
import com.mysema.query.types.EntityPath;
import scala.runtime.AbstractFunction1;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.file.FileDescriptionService;
import se.su.dsv.scipro.file.FileUpload;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Provider;
import javax.persistence.EntityManager;

abstract class AbstractReviewerApprovalServiceImpl<T extends ReviewerApproval> extends AbstractServiceImpl<T, Long> implements ReviewerApprovalService<T> {

    protected final FileDescriptionService fileDescriptionService;
    protected final EventBus eventBus;

    AbstractReviewerApprovalServiceImpl(Provider<EntityManager> em, Class<T> clazz, EntityPath<T> path, final EventBus eventBus, final FileDescriptionService fileDescriptionService) {
        super(em, clazz, path);
        this.eventBus = eventBus;
        this.fileDescriptionService = fileDescriptionService;
    }

    @Override
    public abstract T requestApproval(final Project project, final FileUpload thesis, final String comment);

    protected abstract T newApproval(Project project, FileDescription storedThesis, String comment);

    @Override
    public boolean requiresUpload(final Project project) {
        return findBy(project).forall(new AbstractFunction1<T, Object>() {
            @Override
            public Boolean apply(final T input) {
                return input.isRejected();
            }
        });
    }
}
