package se.su.dsv.scipro.reviewing;

import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Collection;

public interface MyReviewService {
    Iterable<ReviewerApproval> findAll(Filter filter, final Pageable pageable);
    Iterable<ReviewerApproval> findAll(Filter filter);
    long count(Filter filter);
    long countUndecidedRoughDraft(User reviewer);
    long countUndecidedFinalSeminar(User reviewer);
    ReviewerApproval findApproval(Long id);



    @SuppressWarnings("PMD.UnusedPrivateField")
    class Filter implements Serializable{
        private User user;
        private boolean showAll;
        private ReviewerApproval.Step step;
        private Collection<Status> statuses;

        public ReviewerApproval.Step getStep() {
            return step;
        }

        public void setStep(ReviewerApproval.Step step) {
            this.step = step;
        }

        public User getUser() {
            return user;
        }

        public void setUser(User user) {
            this.user = user;
        }

        public boolean isShowAll() {
            return showAll;
        }

        public void setShowAll(boolean showAll) {
            this.showAll = showAll;
        }

        public Collection<Status> getStatuses() {
            return statuses;
        }

        public void setStatuses(Collection<Status> statuses) {
            this.statuses = statuses;
        }
    }
}
