package se.su.dsv.scipro.reviewing;

import lombok.Data;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectStatus;
import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.ProjectType;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;

public interface ProjectFinalSeminarStatisticsService extends GenericService<Project, Long> {
    Long countFinalSeminarStatistics(ProjectFinalSeminarStatisticsService.Filter filter);
    Long countFinalSeminarStatisticsOkFromReviewer(ProjectFinalSeminarStatisticsService.Filter filter);
    Iterable<Project> finalSeminarStatisticsNoOkFromReviewer(ProjectFinalSeminarStatisticsService.Filter filter, Pageable pageable);
    Long countFinalSeminarStatisticsNoOkFromReviewer(ProjectFinalSeminarStatisticsService.Filter filter);

    @Data
    @SuppressWarnings({"PMD.UnusedPrivateField", "UnusedDeclaration"})
    class Filter implements Serializable {
        private Collection<ProjectType> projectTypes;
        private Date createdAfter;
        private Date createdBefore;
        private Collection<ProjectStatus> statuses;
        private Date finalSeminarCreatedAfter;
        private Date finalSeminarCreatedBefore;
    }
}
