package se.su.dsv.scipro.reviewing;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@Entity
@Table(name = "reviewer_deadline_settings")
@Cacheable(true)
@Data
@EqualsAndHashCode(callSuper = true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class ReviewerDeadlineSettings extends DomainObject {

    @Id
    private Long id = null;

    @Basic(optional = false)
    private int roughDraftApproval = 5;

    @Basic(optional = false)
    private int finalSeminarApproval = 2;

    @Basic(optional = false)
    private int finalGrading = 5;

    public ReviewerDeadlineSettings() {
    }

    public ReviewerDeadlineSettings(final Long id) {
        this.id = id;
    }

}
