package se.su.dsv.scipro.security.auth;

import se.su.dsv.scipro.system.*;

import javax.inject.Inject;

class LocalAuthentication implements AuthenticationProvider {
    private final UserService userService;
    private final PasswordService passwordService;

    @Inject
    LocalAuthentication(final UserService userService, final PasswordService passwordService) {
        this.userService = userService;
        this.passwordService = passwordService;
    }

    @Override
    public boolean authenticate(final Credentials credentials) {
        User user = userService.findByUsername(credentials.getUsername());
        if (user == null) {
            return false;
        }

        Password password = passwordService.findByUser(user);
        return password != null && PasswordHandler.isMatch(credentials.getPassword(), password);
    }
}
