package se.su.dsv.scipro.springdata.services;

import lombok.Getter;
import lombok.Setter;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.match.ApplicationPeriod;
import se.su.dsv.scipro.system.*;

import java.io.Serializable;
import java.util.Collection;

public interface SupervisorService extends FilteredService<User, Long, SupervisorService.FilterParams>  {
    Iterable<User> findByResearchArea(ResearchArea area, Pageable pageable);
    Long countByResearchArea(ResearchArea area);

    @Getter
    @Setter
    @SuppressWarnings("PMD.UnusedPrivateField")
    class FilterParams implements Serializable {
        private Unit unit;
        private ResearchArea researchArea;
        private User supervisor;
        private Collection<Language> languages;
        private ApplicationPeriod hasTargetsInApplicationPeriod;
    }
}
