package se.su.dsv.scipro.system;

import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

@Data
@EqualsAndHashCode(callSuper = false, of = "id")
@Entity
@Cacheable
@Table(name = "footer_link")
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class FooterLink extends DomainObject {

    @Id
    @GeneratedValue
    private Long id;

    @Enumerated(EnumType.STRING)
    private FooterColumn footerColumn;

    @Basic(optional = false)
    @NotNull
    private String title;

    @Basic(optional = false)
    @NotNull
    private String url;

    @Basic(optional = false)
    @Column(name = "`order`")
    private Integer order;

    public FooterColumn getFooterColumn() {
        return footerColumn;
    }

    public Integer getOrder() {
        return order;
    }

    public void setOrder(final Integer order) {
        this.order = order;
    }
}