package se.su.dsv.scipro.system;

import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.*;

@Entity
@Table(name = "hash")
@Cacheable(true)
@Data
@EqualsAndHashCode(of = {"id"}, callSuper = false)
@SuppressWarnings("PMD.UnusedPrivateField")
public class Hash extends DomainObject {

    @Id
    @GeneratedValue
    private Long id;

    @Basic
    @Column(name = "hash", nullable = false)
    private String hash;

    @JoinColumn(name = "user")
    @ManyToOne(optional=false)
    private User user;

    public static IHash builder(){
        return new Builder();
    }
    public interface IHash {
        IUser hash(String hash);
    }

    public interface IUser {
        IBuild user(User user);
    }

    public interface IBuild {
        Hash build();
    }

    private static class Builder implements IHash, IUser, IBuild {
        private final Hash instance = new Hash();

        @Override
        public Hash build() {
            return instance;
        }

        @Override
        public IUser hash(String hash) {
            instance.setHash(hash);
            return this;
        }

        @Override
        public IBuild user(User user) {
            instance.setUser(user);
            return this;
        }
    }
}