package se.su.dsv.scipro.system;

import javax.persistence.MappedSuperclass;

@MappedSuperclass
public abstract class LazyDeletableDomainObject extends DomainObject {
    private boolean deleted = false;

    public void setDeleted(boolean deleted) {
        this.deleted = deleted;
    }

    /**
     * @return if the object is lazily deleted or not
     */
    public boolean isDeleted() {
        return deleted;
    }
}
