package se.su.dsv.scipro.system;

import lombok.EqualsAndHashCode;

import javax.persistence.*;
import java.util.Arrays;

@Entity
@Table
@EqualsAndHashCode(callSuper = true)
public class Password extends LazyDeletableDomainObject {
    @Id
    @GeneratedValue
    private Long id;

    @OneToOne(optional = false)
    private User user;

    @Column
    private byte[] hash;

    @Column
    private byte[] salt;

    public Password() {

    }

    public Long getId() {
        return id;
    }

    public byte[] getHash() {
        return hash;
    }

    public byte[] getSalt() {
        return salt;
    }

    public void setHash(byte[] hash) {
        this.hash = hash.clone();
    }

    public void setSalt(byte[] salt) {
        this.salt = salt.clone();
    }

    public void setUser(User user) {
        this.user = user;
    }

    @Override
    public String toString() {
        return "Password{" +
                "id=" + id +
                ", user=" + user +
                ", hash=" + Arrays.toString(hash) +
                ", salt=" + Arrays.toString(salt) +
                '}';
    }
}
