package se.su.dsv.scipro.system;

import javax.inject.Inject;

public class PasswordFacadeImpl implements PasswordFacade {

    private final PasswordService passwordService;
    private final PasswordRepo passwordRepo;
    private final HashService hashService;

    @Inject
    public PasswordFacadeImpl(final PasswordService passwordService, final PasswordRepo passwordRepo, final HashService hashService) {
        this.passwordService = passwordService;
        this.passwordRepo = passwordRepo;
        this.hashService = hashService;
    }

    @Override
    public void setPassword(User user, String password) {
        if (passwordService.findByUser(user)==null){
            char[] passwordInput = password.toCharArray();
            Password pass = new Password();
            pass.setSalt(PasswordHandler.generateSalt());
            pass.setHash(PasswordHandler.generateHash(passwordInput, pass.getSalt()));
            pass.setUser(user);
            passwordRepo.save(pass);
        } else {
            passwordService.updatePassword(user, password);
        }
        hashService.deleteAllHashesForUser(user);
    }
}