package se.su.dsv.scipro.system;

import javax.inject.Inject;
import javax.inject.Named;

@Named
public class PasswordServiceImpl implements PasswordService {

    private final PasswordRepo passwordRepo;

    @Inject
    public PasswordServiceImpl(PasswordRepo passwordRepo) {
        this.passwordRepo = passwordRepo;
    }

    @Override
    public void updatePassword(User user, String passwordInput) {
        if (!passwordInput.isEmpty()) {
            Password password = passwordRepo.findByUser(user);
            password.setSalt(PasswordHandler.generateSalt());
            password.setHash(PasswordHandler.generateHash(passwordInput.toCharArray(), password.getSalt()));
            passwordRepo.save(password);
        }
    }

    @Override
    public Password findByUser(User user) {
        return passwordRepo.findByUser(user);
    }
}
