package se.su.dsv.scipro.system;

import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.*;


@Data
@EqualsAndHashCode(of = "identifier", callSuper = false)
@Entity
@Table(name = "unit")
@Cacheable(true)
@SuppressWarnings("PMD.UnusedPrivateField")
public class Unit extends DomainObject {

    public static final int STRING_MAX_LENGTH = 255;

    @Id
    @GeneratedValue
    private Long id;

    @Column(unique = true)
    private Long identifier;

    @Column(length = STRING_MAX_LENGTH)
    @Basic(optional = false)
    private String title;

    @Basic(optional = true)
    private String matchResponsible;

    public String getMatchResponsible() {
        return matchResponsible;
    }

    public void setMatchResponsible(String matchResponsible){
        this.matchResponsible = matchResponsible;
    }

}
