package se.su.dsv.scipro.system;

import lombok.Data;
import se.su.dsv.scipro.security.auth.roles.Roles;

import java.io.Serializable;
import java.util.Collection;
import java.util.Collections;
import java.util.EnumSet;
import java.util.List;

public interface UserService extends GenericService<User, Long> ,FilteredService<User, Long, UserService.Filter> {
    User findByEmailAddress(String emailAddress);
    User findByUsername(String username);
    User findByExternalIdentifier(Long externalIdentifier);
    List<User> getAutoCompleteUsers(String term, int maxResults);

    @Data
    @SuppressWarnings({"PMD.UnusedPrivateField", "UnusedDeclaration"})
    class Filter implements Serializable {
        private Collection<Roles> roles = EnumSet.allOf(Roles.class);
        private String name;
        private boolean internalUsersOnly;

        public void setRoles(Roles... roles) {
            this.roles.clear();
            Collections.addAll(this.roles, roles);
        }

        public void setRoles(Collection<Roles> roles) {
            this.roles = roles;
        }
    }
}
