CREATE TABLE IF NOT EXISTS `AnnualReview` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `dateCreated` datetime NOT NULL,
  `lastModified` datetime NOT NULL,
  `version` int(11) NOT NULL,
  `year` int(4) NOT NULL,
  `annualReview_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_1lixh18i7nf77ewo7kbcpp0s2` (`annualReview_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

ALTER TABLE `AnnualReview`
  ADD CONSTRAINT `FK_1lixh18i7nf77ewo7kbcpp0s2` FOREIGN KEY (`annualReview_id`) REFERENCES `file_description` (`id`);

CREATE TABLE IF NOT EXISTS `PhD` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `dateCreated` datetime NOT NULL,
  `lastModified` datetime NOT NULL,
  `version` int(11) NOT NULL,
  `basicContract_id` bigint(20) DEFAULT NULL,
  `project_id` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UK_ulti91hg79n6uve40ypk4ep8` (`project_id`),
  KEY `FK_gjws84yb3jwcjtsl566p7elwt` (`basicContract_id`),
  KEY `FK_ulti91hg79n6uve40ypk4ep8` (`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

ALTER TABLE `PhD`
  ADD CONSTRAINT `FK_ulti91hg79n6uve40ypk4ep8` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`),
  ADD CONSTRAINT `FK_gjws84yb3jwcjtsl566p7elwt` FOREIGN KEY (`basicContract_id`) REFERENCES `file_description` (`id`);

CREATE TABLE IF NOT EXISTS `PhD_AnnualReview` (
  `PhD_id` bigint(20) NOT NULL,
  `annualReviews_id` bigint(20) NOT NULL,
  PRIMARY KEY (`PhD_id`,`annualReviews_id`),
  UNIQUE KEY `UK_s7qfudoo5kkayljbmyyssfywi` (`annualReviews_id`),
  KEY `FK_s7qfudoo5kkayljbmyyssfywi` (`annualReviews_id`),
  KEY `FK_8gpidcs94cr95v2mgk5be6x8b` (`PhD_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `PhD_AnnualReview`
  ADD CONSTRAINT `FK_8gpidcs94cr95v2mgk5be6x8b` FOREIGN KEY (`PhD_id`) REFERENCES `PhD` (`id`),
  ADD CONSTRAINT `FK_s7qfudoo5kkayljbmyyssfywi` FOREIGN KEY (`annualReviews_id`) REFERENCES `AnnualReview` (`id`);