CREATE TABLE IF NOT EXISTS `group_thread` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `dateCreated` datetime NOT NULL,
  `lastModified` datetime NOT NULL,
  `version` int(11) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `user` bigint(20) NOT NULL,
  `project_group` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY (`deleted`),
  KEY (`user`),
  KEY (`project_group`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

ALTER TABLE `group_thread`
ADD CONSTRAINT FOREIGN KEY (`user`) REFERENCES `user` (`id`),
ADD CONSTRAINT FOREIGN KEY (`project_group`) REFERENCES `project_group` (`id`);

CREATE TABLE IF NOT EXISTS `group_post` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `dateCreated` datetime NOT NULL,
  `lastModified` datetime NOT NULL,
  `version` int(11) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  `content` LONGTEXT NOT NULL,
  `user` bigint(20) NOT NULL,
  `group_thread` bigint(20) NOT NULL,
  `attachment` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY (`deleted`),
  KEY (`user`),
  KEY (`group_thread`),
  KEY (`attachment`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

ALTER TABLE `group_post`
ADD CONSTRAINT FOREIGN KEY (`user`) REFERENCES `user` (`id`),
ADD CONSTRAINT FOREIGN KEY (`group_thread`) REFERENCES `group_thread` (`id`),
ADD CONSTRAINT FOREIGN KEY (`attachment`) REFERENCES `file_description` (`id`);

CREATE TABLE IF NOT EXISTS `group_thread_group_post` (
  `group_thread` bigint(20) NOT NULL,
  `group_post` bigint(20) NOT NULL,
  PRIMARY KEY (`group_thread`, `group_post`),
  KEY (`group_thread`),
  KEY (`group_post`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `group_thread_group_post`
ADD CONSTRAINT FOREIGN KEY (`group_thread`) REFERENCES `group_thread` (`id`),
ADD CONSTRAINT FOREIGN KEY (`group_post`) REFERENCES `group_post` (`id`);