CREATE TEMPORARY TABLE template AS SELECT project_id FROM NotificationData WHERE event ='THESIS_APPROVAL_REQUESTED' GROUP BY project_id HAVING COUNT(*)=1;

UPDATE NotificationData AS x
  JOIN ReviewerApproval AS y
    ON x.project_id = y.project_id
SET x.event = 'ROUGH_DRAFT_APPROVAL_REQUESTED'
WHERE
  x.event='THESIS_APPROVAL_REQUESTED' AND
  y.type='RoughDraftApproval' AND
  x.project_id IN (SELECT project_id FROM template);

UPDATE NotificationData AS x
  JOIN ReviewerApproval AS y
    ON x.project_id = y.project_id
SET x.event = 'FINAL_SEMINAR_APPROVAL_REQUESTED'
WHERE
  x.event='THESIS_APPROVAL_REQUESTED' AND
  y.type='FinalSeminarApproval' AND
  x.project_id IN (SELECT project_id FROM template);

DROP TABLE template;