CREATE TEMPORARY TABLE approved_template AS SELECT project_id FROM NotificationData WHERE event ='THESIS_APPROVAL_APPROVED' GROUP BY project_id HAVING COUNT(*)=1;
CREATE TEMPORARY TABLE rejected_template AS SELECT project_id FROM NotificationData WHERE event ='THESIS_APPROVAL_REJECTED' GROUP BY project_id HAVING COUNT(*)=1;

UPDATE NotificationData AS n
  JOIN ReviewerApproval AS ra
    ON n.project_id = ra.project_id
    JOIN ReviewerApproval_Decision AS rad
    on rad.ReviewerApproval_id = ra.id
    JOIN Decision AS d
    on d.id=rad.decisions_id
SET n.event = 'ROUGH_DRAFT_APPROVAL_APPROVED'
WHERE
  n.event='THESIS_APPROVAL_APPROVED' AND
  ra.type='RoughDraftApproval' AND
  d.status = 'APPROVED' AND
  n.project_id IN (SELECT project_id FROM approved_template);

UPDATE NotificationData AS n
  JOIN ReviewerApproval AS ra
    ON n.project_id = ra.project_id
  JOIN ReviewerApproval_Decision AS rad
    on rad.ReviewerApproval_id = ra.id
  JOIN Decision AS d
    on d.id=rad.decisions_id
SET n.event = 'FINAL_SEMINAR_APPROVAL_APPROVED'
WHERE
  n.event='THESIS_APPROVAL_APPROVED' AND
  ra.type='FinalSeminarApproval' AND
  d.status = 'APPROVED' AND
  n.project_id IN (SELECT project_id FROM approved_template);

UPDATE NotificationData AS n
  JOIN ReviewerApproval AS ra
    ON n.project_id = ra.project_id
    JOIN ReviewerApproval_Decision AS rad
    on rad.ReviewerApproval_id = ra.id
    JOIN Decision AS d
    on d.id=rad.decisions_id
SET n.event = 'ROUGH_DRAFT_APPROVAL_REJECTED'
WHERE
  n.event='THESIS_APPROVAL_REJECTED' AND
  ra.type='RoughDraftApproval' AND
  d.status = 'REJECTED' AND
  n.project_id IN (SELECT project_id FROM rejected_template);

UPDATE NotificationData AS n
  JOIN ReviewerApproval AS ra
    ON n.project_id = ra.project_id
  JOIN ReviewerApproval_Decision AS rad
    on rad.ReviewerApproval_id = ra.id
  JOIN Decision AS d
    on d.id=rad.decisions_id
SET n.event = 'FINAL_SEMINAR_APPROVAL_REJECTED'
WHERE
  n.event='THESIS_APPROVAL_REJECTED' AND
  ra.type='FinalSeminarApproval' AND
  d.status = 'REJECTED' AND
  n.project_id IN (SELECT project_id FROM rejected_template);


DROP TABLE approved_template;
DROP TABLE rejected_template;