CREATE TABLE `preliminary_grading_report` (
  `id`              BIGINT(20) NOT NULL AUTO_INCREMENT,
  `dateCreated`     DATETIME   NOT NULL,
  `lastModified`    DATETIME   NOT NULL,
  `version`         INT(11)    NOT NULL,
  `submitted`       TINYINT(1) NOT NULL,
  `user_id`         BIGINT(20) NOT NULL,
  `finalSeminar_id` BIGINT(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_user_id` (`user_id`),
  CONSTRAINT `FK_user_id` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`),
  KEY `FK_finalSeminar_id` (`finalSeminar_id`),
  CONSTRAINT `FK_finalSeminar_id` FOREIGN KEY (`finalSeminar_id`) REFERENCES `final_seminar` (`id`)
)
  ENGINE =InnoDB
  DEFAULT CHARSET =utf8;

CREATE TABLE `preliminary_grading_criterion` (
  `id`           BIGINT(20)   NOT NULL AUTO_INCREMENT,
  `dateCreated`  DATETIME     NOT NULL,
  `lastModified` DATETIME     NOT NULL,
  `version`      INT(11)      NOT NULL,
  `feedback`     VARCHAR(2000) DEFAULT NULL,
  `description`  VARCHAR(2000) DEFAULT NULL,
  `title`        VARCHAR(255) NOT NULL,
  `sortOrder`    INT(11)      NOT NULL,
  PRIMARY KEY (`id`)
)
  ENGINE =InnoDB
  DEFAULT CHARSET =utf8;