package se.su.dsv.scipro.activityplan;

import org.junit.Test;
import se.su.dsv.scipro.checklist.ChecklistTemplate;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.IntegrationTest;

import javax.inject.Inject;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import static org.junit.Assert.assertEquals;

public class ActivityTemplateServiceImplIntegrationTest extends IntegrationTest {

    @Inject
    private ActivityTemplateService activityTemplateService;

    @Test
    public void findByChecklistTemplate() throws Exception {
        ActivityTemplate activityTemplate = new ActivityTemplate();
        List<ActivityTemplate> expectedList = Collections.singletonList(activityTemplate);
        activityTemplate.setTitle("title");
        activityTemplate.setDaysOffset(1);

        ChecklistTemplate checklistTemplate = new ChecklistTemplate();
        checklistTemplate.setName("name");
        checklistTemplate.setCreator(createUser());
        activityTemplate.setChecklistTemplate(checklistTemplate);

        save(checklistTemplate);
        save(activityTemplate);

        assertEquals(expectedList, activityTemplateService.findByChecklistTemplate(checklistTemplate));
    }

    private User createUser() {
        User user = User.builder().firstName("Bob").lastName("Sponge").emailAddress("bob@example.com").build();
        return save(user);
    }
}
