package se.su.dsv.scipro.system;

import org.junit.Test;
import se.su.dsv.scipro.test.IntegrationTest;

import javax.inject.Inject;

import static org.hamcrest.CoreMatchers.hasItem;
import static org.hamcrest.CoreMatchers.not;
import static org.junit.Assert.assertThat;

public class ProjectTypeServiceImplTest extends IntegrationTest {
    @Inject
    private ProjectTypeServiceImpl projectTypeService;

    @Test
    public void findAllDeleted() throws Exception {
        ProjectType bachelor = save(new ProjectType(DegreeLevel.FIRST_CYCLE, "Bachelor", "Bachelor"));
        ProjectType master = new ProjectType(DegreeLevel.SECOND_CYCLE, "Master", "Master");
        master.setDeleted(true);
        save(master);

        assertThat(projectTypeService.findAllDeleted(), hasItem(master));
        assertThat(projectTypeService.findAllDeleted(), not(hasItem(bachelor)));
    }
}
