package se.su.dsv.scipro.test;

import se.su.dsv.scipro.forum.dataobjects.ForumPost;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.forum.dataobjects.ProjectThread;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;

public class ForumBuilder {

    private static long ID = 1;

    public ForumPost createPost() {
        return createPost(createThread().getForumThread());
    }

    public ForumPost createPost(ForumThread forumThread) {
        ForumPost post = new ForumPost();
        DomainObjects.injectId(post, ID++);
        post.setPostedBy(new UserBuilder().setFirstName("test").setLastName("test").setEmail("test@test.se").create());
        post.setForumThread(forumThread);
        post.setContent("Test content");
        return post;
    }

    public ProjectThread createThread() {
        ProjectType projectType = new ProjectType(DegreeLevel.FIRST_CYCLE, "Some project type", "Some description");
        Project project = Project.builder().title("Some title").projectType(projectType).build();
        project.setId(1L);
        ForumThread forumThread = new ForumThread();
        forumThread.setSubject("Test subject");
        forumThread.setId(ID++);
        ProjectThread projectThread = new ProjectThread();
        projectThread.setProject(project);
        projectThread.setForumThread(forumThread);
        return projectThread;
    }
}
