package se.su.dsv.scipro.test;

import com.google.inject.AbstractModule;
import com.google.inject.Module;
import modules.CoreModule;
import se.su.dsv.scipro.reviewing.ReviewingModule;
import se.su.dsv.scipro.system.CurrentUser;
import se.su.dsv.scipro.system.User;

import javax.inject.Singleton;

public abstract class IntegrationTest extends GuiceTest {

    @Override
    protected Module moduleUnderTest() {
        return new AbstractModule() {
            @Override
            protected void configure() {
                install(new CoreModule());
                install(new MockFileModule());
                install(new ReviewingModule());
                bind(CurrentUser.class).to(TestUser.class);
            }
        };
    }

    @Singleton
    private static class TestUser implements CurrentUser {

        private User user;

        public void set(User user) {
            this.user = user;
        }

        @Override
        public boolean exists() {
            return user != null;
        }

        @Override
        public User get() {
            return user;
        }
    }
}
