package se.su.dsv.scipro.test;

import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.finalseminar.FinalSeminar;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;

public class SeminarBuilder {

    public FinalSeminar create() {
        FinalSeminar seminar = new FinalSeminar();
        DomainObjects.injectId(seminar, 1L);
        seminar.setDocument(new FileDescription());
        if (seminar.getProject() == null) {
            ProjectType projectType = new ProjectType(DegreeLevel.FIRST_CYCLE, "Some project type", "Some description");
            Project project = Project.builder()
                    .title("Some title")
                    .projectType(projectType)
                    .build();
            seminar.setProject(project);
        }
        return seminar;
    }

}
