package se.su.dsv.scipro.test;

import se.su.dsv.scipro.system.User;

public class UserBuilder {

    private static long ID = 1;

    private String firstName = "Bob";
    private String lastName = "Sponge";
    private String email = "bob@example.com";
    private Long id;

    public User create() {
        User user = new User();
        DomainObjects.injectId(user, id != null ? id : ID++);

        user.setFirstName(firstName);
        user.setLastName(lastName);
        user.setEmailAddress(email);

        return user;
    }

    public UserBuilder setFirstName(String firstName) {
        this.firstName = firstName;
        return this;
    }

    public UserBuilder setLastName(String lastName) {
        this.lastName = lastName;
        return this;
    }

    public UserBuilder setEmail(String email) {
        this.email = email;
        return this;
    }

    public UserBuilder setId(Long id) {
        this.id = id;
        return this;
    }
}
