package se.su.dsv.scipro.workerthreads;

import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static se.su.dsv.scipro.workerthreads.DailySchedule.minutesUntil;

public class DailyScheduleTest {
    @Test
    public void minutes_until_over_midnight() throws Exception {
        assertEquals(45, minutesUntil(23, 30, 0, 15));
    }

    @Test
    public void minutes_until_same_hour_later_minute() throws Exception {
        assertEquals(10, minutesUntil(15, 10, 15, 20));
    }

    @Test
    public void minutes_until_same_hour_earlier_minute() throws Exception {
        assertEquals(24 * 60 - 1, minutesUntil(10, 10, 10, 9));
    }

    @Test
    public void minutes_until_different_hour_later_minute() throws Exception {
        assertEquals(70, minutesUntil(10, 10, 11, 20));
    }

    @Test
    public void minutes_until_different_hour_earlier_minute() throws Exception {
        assertEquals(50, minutesUntil(10, 20, 11, 10));
    }
}
