CREATE TABLE `milestone_activity` (
 `id` bigint(20) NOT NULL AUTO_INCREMENT,
 `dateCreated` datetime NOT NULL,
 `lastModified` datetime NOT NULL,
 `version` int(11) NOT NULL,
 `deleted` tinyint(1) NOT NULL,
 `description` varchar(255) DEFAULT NULL,
 `title` varchar(255) NOT NULL,
 `type` varchar(255) DEFAULT NULL,
 PRIMARY KEY (`id`),
 KEY `deleted_index` (`deleted`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `milestone` (
 `id` bigint(20) NOT NULL AUTO_INCREMENT,
 `dateCreated` datetime NOT NULL,
 `lastModified` datetime NOT NULL,
 `version` int(11) NOT NULL,
 `confirmed` tinyint(1) NOT NULL,
 `activity_id` bigint(20) NOT NULL,
 `project_id` bigint(20) DEFAULT NULL,
 `student_id` bigint(20) DEFAULT NULL,
 PRIMARY KEY (`id`),
 KEY `FKC0841970667E5A5E` (`activity_id`),
 KEY `FKC0841970C1813915` (`project_id`),
 KEY `FKC08419709BD14DD5` (`student_id`),
 CONSTRAINT `FKC0841970667E5A5E` FOREIGN KEY (`activity_id`) REFERENCES `milestone_activity` (`id`),
 CONSTRAINT `FKC08419709BD14DD5` FOREIGN KEY (`student_id`) REFERENCES `role` (`id`),
 CONSTRAINT `FKC0841970C1813915` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Completed peer review 1',  'STUDENT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Completed peer review 2',  'STUDENT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Opponent oral & written',  'STUDENT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Active participation in final seminar/s',  'STUDENT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Defence of thesis in final seminar',  'STUDENT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Supervisor assigned and first meeting held',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Project plan approved by supervisor',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Rough draft approved by reviewer',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Result and discussion completed and approved',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Final seminar created',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Final thesis uploaded',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Thesis approved for final seminar presentation',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Originality report approved',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Preliminary grading reports filled in by supervisor and reviewer',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Revised final version of the submitted thesis',  'PROJECT');

INSERT INTO  `scipro`.`milestone_activity` (`id` ,`dateCreated` ,`lastModified` ,`version` ,`deleted` ,`description` ,`title` ,`type`)
VALUES (NULL ,  '2013-06-05 09:16:00',  '2013-06-05 09:16:02',  '0',  '0',  'No description added..',  'Supervisor and reviewer final grading report submitted',  'PROJECT');