package se.su.dsv.scipro.activityplan;

import org.apache.wicket.feedback.FencedFeedbackPanel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.admin.pages.AbstractAdminProjectPage;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAdminActivityPlanTemplates;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

public class AdminEditActivityTemplatePage extends AbstractAdminProjectPage implements MenuHighlightAdminActivityPlanTemplates {

    public static final String PANEL = "panel";
    public static final String FEEDBACK = "feedback";

    @Inject
    private ActivityPlanTemplateService activityPlanTemplateService;

    public AdminEditActivityTemplatePage(final PageParameters pageParameters) {
        add(new FencedFeedbackPanel(FEEDBACK, this));
        if (pageParameters.get(PageParameterKeys.MAP.get(ActivityPlanTemplate.class)).isNull()){
            add(new EditActivityTemplatePanel(PANEL, new DetachableServiceModel<>(activityPlanTemplateService, new ActivityPlanTemplate())){
                @Override
                public boolean isSysAdminTemplate() {
                    return true;
                }
            });
        } else {
            add(new EditActivityTemplatePanel(PANEL, new DetachableServiceModel<>(activityPlanTemplateService, pageParameters.get(PageParameterKeys.MAP.get(ActivityPlanTemplate.class)).toLong())){
                @Override
                public boolean isSysAdminTemplate() {
                    return true;
                }
            });
        }
    }
}