package se.su.dsv.scipro.activityplan;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.form.AjaxSubmitLink;
import org.apache.wicket.feedback.FencedFeedbackPanel;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.RequiredTextField;
import org.apache.wicket.markup.html.form.TextArea;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import se.su.dsv.scipro.session.SciProSession;

import javax.inject.Inject;

public class SaveAsTemplatePanel extends GenericPanel<ActivityPlan> {
    @Inject
    private ActivityPlanFacade activityPlanFacade;

	public SaveAsTemplatePanel(final String id, final IModel<ActivityPlan> activityPlan){
		super(id, activityPlan);
        final FencedFeedbackPanel feedback = new FencedFeedbackPanel("feedback", this);
        feedback.setOutputMarkupId(true);
        add(feedback);
		final TextField<String> title = new RequiredTextField<>("title",new Model<>(""));
		final TextArea<String> description = new TextArea<>("description",new Model<>(""));
		Form<ActivityPlan> form = new Form<>("form", activityPlan);
		form.add(title);
		form.add(description);
        form.add(new AjaxSubmitLink("save") {
            @Override
            protected void onSubmit(final AjaxRequestTarget target, final Form<?> form) {
                target.add(feedback);
                ActivityPlanTemplate schedule = activityPlanFacade.createTemplateFromSchedule(
                        SaveAsTemplatePanel.this.getModelObject(),
                        SciProSession.get().getUser(),
                        title.getModelObject(),
                        description.getModelObject());
                title.setModelObject("");
                title.clearInput();
                description.setModelObject("");
                description.clearInput();
                success(getString("saved.as.template", Model.of(schedule)));
            }
            @Override
            protected void onError(final AjaxRequestTarget target, final Form<?> form) {
                target.add(feedback);
            }
        });
		add(form);
	}
}
