package se.su.dsv.scipro.activityplan;


import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyProjects;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorProjectDetailsPage;
import se.su.dsv.scipro.system.ProjectModule;

@Authorization(authorizedRoles={Roles.SUPERVISOR})
@ProjectModuleComponent(ProjectModule.ACTIVITY_PLAN)
public class SupervisorActivityPlanPage extends AbstractSupervisorProjectDetailsPage implements MenuHighlightSupervisorMyProjects {
	
	public SupervisorActivityPlanPage(final PageParameters pp){
		super(pp);
		if(projectModel.getObject() == null) {
            add(new Label("activityPlan", "No project selected"));
        } else {
            add(new SupervisorActivityPlanPanel("activityPlan", projectModel));
        }
	}
}
