package se.su.dsv.scipro.admin.pages;

import org.apache.wicket.feedback.FencedFeedbackPanel;
import se.su.dsv.scipro.admin.pages.settings.*;
import se.su.dsv.scipro.components.AbstractMenuPanel;
import se.su.dsv.scipro.finalseminar.AdminFinalSeminarSettingsPage;
import se.su.dsv.scipro.generalsystemsettings.AdminGeneralSettingsPage;
import se.su.dsv.scipro.milestones.AdminMileStoneSettingsPage;
import se.su.dsv.scipro.notifications.settings.pages.AdminNotificationSettingsPage;
import se.su.dsv.scipro.peer.AdminPeerSettingsPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;

import java.util.ArrayList;
import java.util.List;

@Authorization(authorizedRoles = { Roles.SYSADMIN })
public abstract class AbstractAdminSystemPage extends AbstractAdminPage {
    protected AbstractAdminSystemPage() {
		add(new FencedFeedbackPanel("feedbackPanel", this));
		
		add(new AbstractMenuPanel("menuPanel", AbstractAdminSystemPage.class, this.getClass()){
			@Override
			protected List<MenuItem> getItemList() {
				final List<MenuItem> items = new ArrayList<>();
				items.add(new MenuItem("General settings", AdminGeneralSettingsPage.class));
				items.add(new MenuItem("Final seminar settings", AdminFinalSeminarSettingsPage.class));
                items.add(new MenuItem("Turnitin settings", TurnitinSettingsPage.class));
				items.add(new MenuItem("Peer settings", AdminPeerSettingsPage.class));
				items.add(new MenuItem("Type settings", AdminProjectTypeSettingsPage.class));
                items.add(new MenuItem("Notification settings", AdminNotificationSettingsPage.class));
                items.add(new MenuItem("Milestone settings", AdminMileStoneSettingsPage.class));
                items.add(new MenuItem("Maintenance", SystemMaintenancePage.class));
                items.add(new MenuItem("Project module settings", AdminProjectModuleSettingsPage.class));
                items.add(new MenuItem("Footer settings", AdminFooterSettingsPage.class));
                items.add(new MenuItem("Reviewer deadline settings", AdminReviewerDeadlineSettingsPage.class));
                items.add(new MenuItem("Language", AdminLanguageSettingsPage.class));
				items.add(new MenuItem("Forum mail settings", AdminForumSettingsPage.class));
                return items;
			}

			@Override
			protected MenuType getMenuType() {
				return MenuType.HORIZONTAL;
			}
			
		});
	}
}