package se.su.dsv.scipro.admin.pages;

import org.apache.wicket.markup.html.form.CheckBox;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.PasswordTextField;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;
import se.su.dsv.scipro.forummail.ForumMailSettings;
import se.su.dsv.scipro.forummail.ForumMailSettingsService;

import javax.inject.Inject;

public class AdminForumSettingsPage extends AbstractAdminSystemPage {

    @Inject
    private ForumMailSettingsService forumMailSettingsService;

    public AdminForumSettingsPage() {
        add(new SettingsForm("form", new CompoundPropertyModel<>(getSettings())));
    }

    private class SettingsForm extends Form<ForumMailSettings> {
        public SettingsForm(String id, CompoundPropertyModel<ForumMailSettings> model) {
            super(id, model);
            add(new CheckBox("enabled"));
            add(new TextField<String>("host"));
            add(new TextField<Integer>("port"));
            add(new TextField<String>("replyAddress"));
            add(new TextField<String>("account"));
            PasswordTextField password = new PasswordTextField("password");
            password.setResetPassword(false);
            password.setRequired(false);
            add(password);
        }

        @Override
        protected void onSubmit() {
            success(getString("saved"));
            forumMailSettingsService.save(getModelObject());
        }
    }

    private IModel<ForumMailSettings> getSettings() {
        return new LoadableDetachableModel<ForumMailSettings>() {
            @Override
            protected ForumMailSettings load() {
                return forumMailSettingsService.getSettings();
            }
        };
    }

}
