package se.su.dsv.scipro.admin.panels;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import se.su.dsv.scipro.peer.PeerRequestService;
import se.su.dsv.scipro.peer.RequestStatus;

import javax.inject.Inject;

public class PeerRequestStatsPanel extends Panel {

	@Inject
	private PeerRequestService peerRequestService;
	
	public PeerRequestStatsPanel(String id) {
		super(id);
		
		final long countRequests = peerRequestService.count();
		add(new Label("allRequests", String.valueOf(countRequests)));
		
		final long waitingRequests = peerRequestService.countByStatus(RequestStatus.WAITING);
		add(new Label("waitingRequests", String.valueOf(waitingRequests)));
		
		final long takenRequests = peerRequestService.countByStatus(RequestStatus.TAKEN);
		add(new Label("takenRequests", String.valueOf(takenRequests)));
		
		final long finishedRequests = peerRequestService.countByStatus(RequestStatus.FINISHED);
		add(new Label("finishedRequests", String.valueOf(finishedRequests)));
		
		final long canceledRequests = peerRequestService.countByStatus(RequestStatus.CANCELED);
		add(new Label("canceledRequests", String.valueOf(canceledRequests)));
	}

}
