package se.su.dsv.scipro.checklists;

import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.PropertyListView;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.checklist.ChecklistAnswer;
import se.su.dsv.scipro.checklist.ChecklistQuestion;

import java.util.List;

public class ChecklistAnswerCommentPanel extends Panel {

    static final String TABLE = "table";
    static final String ANSWERS = "answers";
    static final String NAME = "user.fullName";
    static final String COMMENT = "comment";

    public ChecklistAnswerCommentPanel(String id, IModel<ChecklistQuestion> question) {
        super(id, question);

        WebMarkupContainer table = new WebMarkupContainer(TABLE) {
            @Override
            protected void onConfigure() {
                super.onConfigure();
                setVisibilityAllowed(!getAnswers().getObject().isEmpty());
            }
        };

        table.add(new PropertyListView<ChecklistAnswer>(ANSWERS, getAnswers()) {
            @Override
            protected void populateItem(final ListItem<ChecklistAnswer> item) {
                item.add(new Label(NAME));
                item.add(new Label(COMMENT));
                item.setVisibilityAllowed(hasComment(item));
            }
        });

        add(table);
    }

    private boolean hasComment(ListItem<ChecklistAnswer> item) {
        String comment = item.getModelObject().getComment();
        return comment != null && !comment.isEmpty();
    }

    private IModel<List<ChecklistAnswer>> getAnswers() {
        return new PropertyModel<>(getDefaultModel(), ANSWERS);
    }
}
