package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.IChoiceRenderer;
import org.apache.wicket.model.IModel;

import java.util.List;


public abstract class AjaxDropDownChoice<T> extends DropDownChoice<T> {

    public AjaxDropDownChoice(String id, IModel<T> model, IModel<List<T>> choices) {
        super(id, model, choices);
    }

    public AjaxDropDownChoice(String id, IModel<T> model, IModel<List<T>> choices, IChoiceRenderer<T> renderer) {
        super(id, model, choices, renderer);
    }

    public AjaxDropDownChoice(String id, IModel<T> model, List<? extends T> choices) {
        super(id, model, choices);
    }

    public AjaxDropDownChoice(final String id, final List<T> choices, final IChoiceRenderer<T> renderer) {
        super(id, choices, renderer);
    }

    @Override
    protected void onInitialize() {
        super.onInitialize();
        add(new AjaxFormComponentUpdatingBehavior("onchange") {
            @Override
            protected void onUpdate(AjaxRequestTarget target) {
                onNewSelection(target, getModelObject());
            }
        });
    }

    public abstract void onNewSelection(AjaxRequestTarget target, T objectSelected);
}
