package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.attributes.AjaxCallListener;
import org.apache.wicket.ajax.attributes.AjaxRequestAttributes;
import org.apache.wicket.ajax.attributes.ThrottlingSettings;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.ajax.json.JsonFunction;
import org.apache.wicket.util.time.Duration;

public abstract class AutoSavingBehaviour extends AjaxFormComponentUpdatingBehavior {

    public static final String EVENT = "keydown";
    public static final int AUTO_SAVE_INTERVAL_IN_SECONDS = 10;

    public AutoSavingBehaviour() {
        super(EVENT);
    }

    @Override
    protected abstract void onUpdate(AjaxRequestTarget target);

    @Override
    protected void updateAjaxAttributes(AjaxRequestAttributes attributes) {
        super.updateAjaxAttributes(attributes);

        attributes.setThrottlingSettings(new ThrottlingSettings(getComponent().getPath(), Duration.seconds(AUTO_SAVE_INTERVAL_IN_SECONDS)));
        attributes.getAjaxCallListeners().add(new AjaxCallListener()
                .onFailure(new JsonFunction("alert('Auto-saving just failed, you should take precautions to not lose any text and refresh the page afterwards.');")));
    }
}
