package se.su.dsv.scipro.components;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.FormComponent;
import org.apache.wicket.markup.html.form.validation.AbstractFormValidator;
import org.apache.wicket.util.lang.Args;

import java.util.Date;

public class DatesValidator extends AbstractFormValidator {
    private final FormComponent[] components;

    public DatesValidator(FormComponent<Date> formComponent1, FormComponent<Date> formComponent2) {
        Args.notNull(formComponent1, "formComponent1");
        Args.notNull(formComponent2, "formComponent2");
        components = new FormComponent[]{formComponent1, formComponent2};
    }

    @Override
    public FormComponent<?>[] getDependentFormComponents() {
        return components;
    }

    @Override
    public void validate(Form<?> form) {
        Date firstDate = (Date) components[0].getConvertedInput();
        Date secondDate = (Date) components[1].getConvertedInput();

        if (firstDate.after(secondDate)) {
            error(components[0]);
        }
    }
}