package se.su.dsv.scipro.components;

import org.apache.wicket.Component;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;

import java.util.List;

public abstract class DisplayMultiplesPanel<T> extends Panel {
    public abstract Component getComponent(String componentId, IModel<T> t);
    public DisplayMultiplesPanel(String id, IModel<? extends List<? extends T>> model) {
        super(id, model);
        add(new ListView<T>(LIST, model) {
            @Override
            protected void populateItem(ListItem<T> item) {
                item.add(getComponent(COMPONENT, item.getModel()));
            }
        });
    }

    public static final String LIST = "list";
    public static final String COMPONENT = "component";
}