package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.html.panel.ComponentFeedbackPanel;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.system.User;

/**
 * User: fred
 * Date: 7/19/12
 */
public abstract class EmployeeAutoCompleteDivPanel extends Panel {

    public abstract void onNewEmployeeSelection(AjaxRequestTarget target, User newSelection);

    public EmployeeAutoCompleteDivPanel(String id, IModel<User> employeeModel) {
        super(id, employeeModel);
        final ComponentFeedbackPanel feedbackPanel = new ComponentFeedbackPanel("feedback", this);
        feedbackPanel.setOutputMarkupId(true);
        add(feedbackPanel);

        EmployeeAutoComplete eac = new EmployeeAutoComplete("eac") {
            @Override
            protected void action(AjaxRequestTarget target, User newSelection) {
                onNewEmployeeSelection(target, newSelection);
            }
            @Override
            public boolean getAllowClear(){
                return false;
            }
        };
        add(eac);
        eac.setModelObject(employeeModel.getObject());
    }

}
