package se.su.dsv.scipro.components;

import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.ISortableDataProvider;
import org.apache.wicket.extensions.markup.html.repeater.data.table.export.ExportToolbar;
import org.apache.wicket.model.Model;
import se.su.dsv.scipro.io.ExcelExporter;

import java.util.List;

public class ExportableDataPanel<T, S> extends DefaultDataPanel<T, S> {
    public ExportableDataPanel(String id, List<? extends IColumn<T, S>> columns, ISortableDataProvider<T, S> dataProvider) {
        super(id, columns, dataProvider);
    }

    public ExportableDataPanel(final String id, final List<? extends IColumn<T, S>> columns, final ISortableDataProvider<T, S> dataProvider, final long rowsPerPage) {
        super(id, columns, dataProvider, rowsPerPage);

    }

    @Override
    protected void onInitialize() {
        super.onInitialize();
        addBottomToolbar(new ExportToolbar(this, new Model<>("Download as"), new Model<>("excel")).addDataExporter(new ExcelExporter()));
    }
}
