package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.extensions.markup.html.basic.SmartLinkMultiLineLabel;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;

public class InfoPanel extends GenericPanel<String> {

    public static final String CONTAINER = "container";
    public static final String INFO = "info";
    public static final String SHOW = "show";
    private boolean infoVisible = false;

    public InfoPanel(String id, IModel<String> model) {
        super(id, model);

        final WebMarkupContainer container = new WebMarkupContainer(CONTAINER);
        container.setOutputMarkupId(true);
        add(container);

        final SmartLinkMultiLineLabel info = new SmartLinkMultiLineLabel(INFO, model){
            @Override
            protected void onConfigure() {
                setVisibilityAllowed(infoVisible);
            }
        };
        container.add(info);

        container.add(new AjaxLink<Void>(SHOW) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                target.add(container);
                infoVisible = !infoVisible;
            }
        });
    }
}
