package se.su.dsv.scipro.dataproviders;

import org.apache.wicket.extensions.markup.html.repeater.data.sort.SortOrder;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.FilteredService;

import java.util.Iterator;

public class FilteredDataProvider<T extends DomainObject, F> extends GenericDataProvider<T> {
    private final FilteredService<T, Long, F> filteredService;
    private final IModel<F> filter;

    public FilteredDataProvider(FilteredService<T, Long, F> filteredService, IModel<F> filter) {
        super(filteredService);
        this.filteredService = filteredService;
        this.filter = filter;
    }

    public FilteredDataProvider(FilteredService<T, Long, F> filteredService, IModel<F> filter, String sortParam, SortOrder sortOrder) {
        super(filteredService);
        this.filteredService = filteredService;
        this.filter = filter;
        this.setSort(sortParam, sortOrder);
    }

    @Override
    public Iterator<? extends T> iterator(long first, long count) {
        return filteredService.findAll(filter.getObject(), getPage(first, count)).iterator();
    }

    @Override
    public long size() {
        return filteredService.count(filter.getObject());
    }
}
