package se.su.dsv.scipro.dataproviders;

import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.GenericService;

import java.util.Iterator;

public class GenericDataProvider<T extends DomainObject> extends SortableDataProvider<T, String> {
    private final GenericService<T, Long> genericService;

    public GenericDataProvider(GenericService<T, Long> genericService) {
        this.genericService = genericService;
    }

    @Override
    public Iterator<? extends T> iterator(long first, long count) {
        return genericService.findAll(getPage(first, count)).iterator();
    }

    protected PageAdapter getPage(long first, long count) {
        return new PageAdapter(first, count, getSort());
    }

    @Override
    public long size() {
        return genericService.count();
    }

    @Override
    public IModel<T> model(T object) {
        return new DetachableServiceModel<>(genericService, object);
    }
}
