package se.su.dsv.scipro.datatables;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.attributes.AjaxCallListener;
import org.apache.wicket.ajax.attributes.AjaxRequestAttributes;
import org.apache.wicket.ajax.markup.html.form.AjaxCheckBox;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;

public abstract class AjaxCheckboxWrapper extends Panel {

    public abstract void onChange(AjaxRequestTarget target, boolean selected);

    public AjaxCheckboxWrapper(String id, IModel<Boolean> model) {
        super(id);
        add(new AjaxCheckBox(CHECKBOX, model) {
            @Override
            protected void onUpdate(AjaxRequestTarget target) {
                onChange(target, getModelObject());
            }

            @Override
            protected void updateAjaxAttributes(AjaxRequestAttributes attributes) {
                super.updateAjaxAttributes(attributes);
                AjaxCallListener ajaxCallListener = new AjaxCallListener();
                ajaxCallListener.onPrecondition("if (!confirm('Are you sure?')) {window.location.reload(); return false;}");
                attributes.getAjaxCallListeners().add(ajaxCallListener);
            }
        });
    }

    public static final String CHECKBOX = "checkbox";
}