package se.su.dsv.scipro.date;

import org.apache.wicket.util.io.IClusterable;
import org.joda.time.DateTime;

import java.util.Date;

public class DatePickerModel implements IClusterable {

    private Date startDate;
    private Date endDate;

    public DatePickerModel(Date startDate, Date endDate) {
        if (startDate == null) {
            setStartDate(new Date());
        } else {
            setStartDate(startDate);
        }

        if (endDate == null) {
            setEndDate(new Date());
        } else {
            setEndDate(endDate);
        }
    }

    public void setStartDate(Date startDate) {
        if (startDate != null) {
            DateTime tmp = new DateTime(startDate);
            this.startDate = tmp.withTimeAtStartOfDay().toDate();
        } else {
            this.startDate = null;
        }
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setEndDate(Date endDate) {
        if (endDate != null) {
            DateTime tmp = new DateTime(endDate);
            tmp = tmp.withTimeAtStartOfDay();
            tmp = tmp.minusSeconds(1);
            tmp = tmp.plusDays(1);
            this.endDate = tmp.toDate();
        } else {
            this.endDate = null;
        }
    }

    public Date getEndDate() {
        return endDate;
    }

}
