package se.su.dsv.scipro.finalseminar;

import org.apache.wicket.markup.html.form.upload.FileUpload;
import se.su.dsv.scipro.components.AbstractUploadForm;
import se.su.dsv.scipro.files.WicketFileUpload;
import se.su.dsv.scipro.session.SciProSession;

import javax.inject.Inject;

public class NewSeminarDocumentUploadForm extends AbstractUploadForm {

    @Inject
    private FinalSeminarUploadController seminarUploadController;

    private FinalSeminar seminar;

    public NewSeminarDocumentUploadForm(final FinalSeminar seminar) {
        super();
        this.seminar = seminar;
    }

    @Override
    protected void onNewUpload(final FileUpload fileUpload) {
        if (SciProSession.exists()) {
            seminarUploadController.storeSeminarDocument(
                        WicketFileUpload.from(fileUpload), seminar);
        }
    }
}
