package se.su.dsv.scipro.finalseminar;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.util.AjaxConfirmationLink;

import javax.inject.Inject;

public abstract class ParticipateColumnPanel extends Panel {

    public static final String LINK = "link";
    public static final String PARTICIPATE_CONFIRMATION = "Are you sure you want to participate on this seminar?";

    @Inject
    private FinalSeminarService finalSeminarService;

    private AjaxLink participateLink;
    private ParticipateColumnPanel participateColumnPanel;

    public abstract void onClick(AjaxRequestTarget target, IModel<FinalSeminar> clickedModel);

    public ParticipateColumnPanel(String id, final IModel<FinalSeminar> model) {
        super(id, model);

        participateColumnPanel = this;

        participateLink = new AjaxConfirmationLink(LINK, PARTICIPATE_CONFIRMATION) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                participateColumnPanel.onClick(target, model);
                participateLink.setEnabled(false);
                target.add(participateLink);
            }

            @Override
            protected void onConfigure() {
                setEnabled(finalSeminarService.canParticipate(SciProSession.get().getUser(), model.getObject()));
            }
        };

        participateLink.setOutputMarkupId(true);
        add(participateLink);
    }
}
