package se.su.dsv.scipro.forum.pages;

import org.apache.wicket.RestartResponseException;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.util.string.StringValue;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.forum.pages.threaded.SupervisorThreadedForumPage;
import se.su.dsv.scipro.forum.pages.threaded.SupervisorViewForumThreadPage;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorProjectDetailsPage;
import se.su.dsv.scipro.system.ProjectModule;
import se.su.dsv.scipro.util.PageParameterKeys;

@ProjectModuleComponent(ProjectModule.FORUM)
public class SupervisorForumBasePage extends AbstractSupervisorProjectDetailsPage {

    public SupervisorForumBasePage(PageParameters pp) {
        super(pp);

        StringValue value = pp.get(PageParameterKeys.MAP.get(ForumThread.class));
        Long threadId = null;
        if(!value.isNull()) {
            threadId = value.toLongObject();
        }
        if(threadId==null) {
            throw new RestartResponseException(SupervisorThreadedForumPage.class, pp);
        }
        throw new RestartResponseException(SupervisorViewForumThreadPage.class, pp);
    }
}
