package se.su.dsv.scipro.generalsystemsettings;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.LoadableDetachableModel;

import javax.inject.Inject;

public abstract class GeneralSystemSettingsForm extends Form<GeneralSystemSettings> {
	

	@Inject
	protected GeneralSystemSettingsService settingsService;
	
	public GeneralSystemSettingsForm(String id) {
		super(id);
        setModel(new CompoundPropertyModel<>(getSettingsModel()));
        addFields();
	}

    private LoadableDetachableModel<GeneralSystemSettings> getSettingsModel() {
        return new LoadableDetachableModel<GeneralSystemSettings>() {
            @Override
            protected GeneralSystemSettings load() {
                return settingsService.getGeneralSystemSettingsInstance();
            }
        };
    }

    @Override
	protected void onSubmit() {
		settingsService.save(getModelObject());
		info("Settings saved");
	}

	protected abstract void addFields();
}
