package se.su.dsv.scipro.grading;

import com.google.common.base.Joiner;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.report.GradingCriterion;
import se.su.dsv.scipro.report.SupervisorGradingReport;
import se.su.dsv.scipro.system.User;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class NoPointNoFeedbackGradingReportPdf implements GradingReportPdf {

    private final IModel<SupervisorGradingReport> supervisorGradingReport;

    public NoPointNoFeedbackGradingReportPdf(IModel<SupervisorGradingReport> supervisorGradingReport) {
        this.supervisorGradingReport = supervisorGradingReport;
    }

    @Override
    public String getProjectTitle() {
        return supervisorGradingReport.getObject().getProject().getTitle();
    }

    @Override
    public String getProjectType() {
        return supervisorGradingReport.getObject().getProject().getProjectType().getName();
    }

    @Override
    public String getAuthorName() {
        return "";
    }

    @Override
    public String getAuthorNames() {
        List<String> names = new ArrayList<>();
        for (User student : supervisorGradingReport.getObject().getProject().getProjectParticipants()) {
            names.add(student.getFullName());
        }
	    return Joiner.on(", ").join(names);
    }

    @Override
    public String getSupervisorName() {
        return supervisorGradingReport.getObject().getProject().getSupervisorName();
    }

    @Override
    public String getReviewerName() {
        return supervisorGradingReport.getObject().getProject().getReviewerName();
    }

    @Override
    public String getPlagiarismFeedback() {
        return "";
    }

    @Override
    public String getGrade() {
        return "";
    }

    @Override
    public Date getLastModified() {
        return supervisorGradingReport.getObject().getLastModified();
    }

    @Override
    public List<GradingCriterion> getGradingCriteria() {
        List<GradingCriterion> criteria = new ArrayList<>(supervisorGradingReport.getObject().getGradingCriteria());
        for (GradingCriterion criterion : criteria){
            criterion.setFeedback(null);
            criterion.setPoints(null);
        }
        return criteria;
    }

    @Override
    public String getProjectTypeName() {
        return supervisorGradingReport.getObject().getProjectType().getName();
    }
}
