package se.su.dsv.scipro.group;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAuthorMyGroups;
import se.su.dsv.scipro.forum.GroupForumService;
import se.su.dsv.scipro.forum.dataobjects.GroupThread;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.forum.panels.threaded.SubmitForumThreadPanel;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

public class CreateThreadPage extends AbstractAuthorGroupPage implements MenuHighlightAuthorMyGroups {

    @Inject
    private GroupForumService groupForumService;

    public CreateThreadPage(final PageParameters parameters) {
        super(parameters);
        add(new SubmitForumThreadPanel<GroupThread>("form", new GroupForum(groupForumService, getGroup())) {
            @Override
            public void onThreadCreated(final GroupThread thread) {
                PageParameters pp = new PageParameters(parameters)
                        .set(PageParameterKeys.MAP.get(ForumThread.class), thread.getId());
                setResponsePage(ViewThreadPage.class, pp);
            }
        });
    }
}
