package se.su.dsv.scipro.group;

import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.file.FileUpload;
import se.su.dsv.scipro.forum.Forum;
import se.su.dsv.scipro.forum.GroupForumService;
import se.su.dsv.scipro.forum.dataobjects.GroupThread;
import se.su.dsv.scipro.system.User;

import java.util.Set;

public class GroupForum implements Forum<GroupThread> {
    private final GroupForumService groupForumService;
    private final IModel<Group> groupModel;

    public GroupForum(final GroupForumService groupForumService, final IModel<Group> groupModel) {
        this.groupForumService = groupForumService;
        this.groupModel = groupModel;
    }

    @Override
    public GroupThread createThread(final User user, final String subject, final String content, final Set<FileUpload> attachments) {
        Group group = groupModel.getObject();

        return groupForumService.createThread(
                group,
                user,
                subject,
                content,
                attachments);
    }

}
