
package se.su.dsv.scipro.match;

import se.su.dsv.scipro.admin.pages.AbstractAdminPage;
import se.su.dsv.scipro.components.AbstractMenuPanel;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAdminApplicationPeriod;
import se.su.dsv.scipro.projectpartner.AdminProjectPartnerPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;

import java.util.ArrayList;
import java.util.List;

@Authorization(authorizedRoles = {Roles.SYSADMIN, Roles.ADMIN})
public abstract class AbstractAdminMatchPage extends AbstractAdminPage {
    public AbstractAdminMatchPage() {
        add(new AbstractMenuPanel("menuPanel", AbstractAdminMatchPage.class, this.getClass()) {
            @Override
            protected List<MenuItem> getItemList() {
                final List<MenuItem> items = new ArrayList<>();
                items.add(new MenuItem("Ideas", AdminManageIdeaPage.class));
                items.add(new MenuItem("Extended ideas", AdminIdeaPopupPage.class, true));
                items.add(new MenuItem("Keywords and research areas", AdminKeywordPage.class));
                items.add(new MenuItem("Units", AdminUnitPage.class));
                items.add(new MenuItem("Programs", AdminProgramPage.class));
                items.add(new MenuItem("Application periods", AdminManageMatchPeriodsPage.class, MenuHighlightAdminApplicationPeriod.class));
                items.add(new MenuItem("Project partner", AdminProjectPartnerPage.class));
                return items;
            }
            @Override
            protected MenuType getMenuType() {
                return MenuType.HORIZONTAL;
            }
        });
    }
}