package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;

public class AdminKeywordSwitchPanel extends Panel {

    private AdminKeywordCrudPanel keywordPanel;
    private AdminResearchAreaCrudPanel areaPanel;
    private Panel currentPanel;

    public AdminKeywordSwitchPanel(String id) {
        super(id);
        keywordPanel = new AdminKeywordCrudPanel(PANEL);
        areaPanel = new AdminResearchAreaCrudPanel(PANEL);
        currentPanel = keywordPanel;
        setOutputMarkupId(true);

        add(new Link<Void>(KEYWORD_LINK) {
            @Override
            public void onClick() {
                currentPanel.replaceWith(keywordPanel);
                currentPanel = keywordPanel;
            }

            @Override
            protected void onConfigure() {
                super.onConfigure();
                setEnabled(!currentPanel.equals(keywordPanel));
            }

        });
        add(new Link<Void>(AREA_LINK) {
            @Override
            public void onClick() {
                currentPanel.replaceWith(areaPanel);
                currentPanel = areaPanel;
            }

            @Override
            protected void onConfigure() {
                super.onConfigure();
                setEnabled(!currentPanel.equals(areaPanel));
            }
        });
        add(currentPanel);
    }

    static final String PANEL = "panel";
    static final String KEYWORD_LINK = "keywordLink";
    static final String AREA_LINK = "areaLink";

}
