package se.su.dsv.scipro.match;

import org.apache.wicket.markup.ComponentTag;
import org.apache.wicket.markup.html.link.ExternalLink;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.applicationperiod.ApplicationPeriodInfoPanel;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightProjectIdeas;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;

@Authorization(authorizedRoles = {Roles.AUTHOR})
public class ProjectIdeaStartPage extends AbstractIdeaProjectPage implements MenuHighlightProjectIdeas {

    @Inject
    private GeneralSystemSettingsService systemSettingsService;

    public ProjectIdeaStartPage(PageParameters pp) {
        super(pp);
        User author = getUser();
        add(new FeedbackPanel("feedback"));
        add(new ProjectMyIdeasPanel("myIdeasPanel", author));
        add(new ApplicationPeriodInfoPanel("infoPanel", false));
        addMoreInfoAboutIdeaLink();
    }

    private void addMoreInfoAboutIdeaLink() {
        final String link = systemSettingsService.getExternalGettingStartedWithIdeaURL();
        add(new ExternalLink("moreInfo", link) {
            @Override
            protected void onComponentTag(ComponentTag tag) {
                super.onComponentTag(tag);
                tag.put("target", "_blank");
            }
            @Override
            protected void onConfigure() {
                setVisible(link != null);
            }
        });
    }
}
