package se.su.dsv.scipro.match;

import org.apache.wicket.RestartResponseException;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightProjectIdeas;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

@Authorization(authorizedRoles={Roles.AUTHOR})
public class ProjectNewAllSupervisorIdeasPage extends AbstractIdeaProjectPage implements MenuHighlightProjectIdeas {

    @Inject
    private ApplicationPeriodService applicationPeriodService;

    public ProjectNewAllSupervisorIdeasPage(PageParameters pp) {
        super(pp);
        addFeedback();

        if (pp.get(PageParameterKeys.MAP.get(ApplicationPeriod.class)).isNull()) {
            throw new RestartResponseException(ProjectIdeaStartPage.class);
        }

        final ApplicationPeriod applicationPeriod = applicationPeriodService.findOne(pp.get(PageParameterKeys.MAP.get(ApplicationPeriod.class)).toLong());

        add(new ProjectAllSupervisorIdeasPanel("ideaPanel", applicationPeriod){
            @Override
            protected void onConfigure() {
                super.onConfigure();
                setVisibilityAllowed(applicationPeriodService.isOpen(applicationPeriod) || applicationPeriodService.hasOpenExemption(applicationPeriod, SciProSession.get().getUser()));
            }
        });
	}
	
	private void addFeedback() {
        add(new FeedbackPanel("feedback").setOutputMarkupId(true));
	}
}
