package se.su.dsv.scipro.match;

import com.google.inject.Inject;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.util.string.StringValue;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyIdeas;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.util.PageParameterKeys;

public class SupervisorIdeaDetailsPage extends AbstractSupervisorProjectIdeaPage implements MenuHighlightSupervisorMyIdeas {

    @Inject
    private IdeaService ideaService;

    public SupervisorIdeaDetailsPage(PageParameters pp) {
        super(pp);

        StringValue ideaId = pp.get(PageParameterKeys.MAP.get(Idea.class));

        DetachableServiceModel<Idea> ideaModel = new DetachableServiceModel<>(ideaService, ideaId.toLongObject());

        add(new SupervisorIdeaDetailsPanel("ideaDetails", ideaModel));
    }
}
