package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.EmptyPanel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.util.string.StringValue;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyIdeas;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

public class SupervisorIdeaSubmissionPage extends AbstractSupervisorProjectIdeaPage implements MenuHighlightSupervisorMyIdeas {
	
	@Inject
	private IdeaService ideaService;

	public SupervisorIdeaSubmissionPage(PageParameters pp) {
		super(pp);

        Long ideaId = null;
        StringValue value = pp.get(PageParameterKeys.MAP.get(Idea.class));
        if(!value.isNull()) {
            ideaId = value.toLongObject();
        }

		Idea idea;
		boolean isNewIdea;
	
		if(ideaId!=null) {
			idea = ideaService.findOne(ideaId);
			isNewIdea = false;
		}
		else {
			idea = new Idea();
			isNewIdea = true;
		}

        if (SciProSession.get().hasActualRole(Roles.SUPERVISOR)){
            add(new SupervisorEditIdeaPanel("ideaPanel", new DetachableServiceModel<>(ideaService, idea), isNewIdea){
                @Override
                protected void onConfigure(){
                    setVisibilityAllowed(SciProSession.get().hasActualRole(Roles.SUPERVISOR));
                }
            });
        } else {
            add(new EmptyPanel("ideaPanel"));
        }

        add(new Label("noLabel", "You don't have the Employee role, so you cant create ideas here."){
            @Override
            protected void onConfigure(){
                setVisibilityAllowed(!SciProSession.get().hasActualRole(Roles.SUPERVISOR));
            }
        });
	}

}
