package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyIdeas;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

public class SupervisorSelectableStudentIdeasPage extends AbstractSupervisorProjectIdeaPage implements MenuHighlightSupervisorMyIdeas {

    public static final String BACK_LINK = "backLink";
    @Inject
    private ApplicationPeriodService applicationPeriodService;

    public SupervisorSelectableStudentIdeasPage(final PageParameters pp) {
        super(pp);
        add(new BookmarkablePageLink<Void>(BACK_LINK, SupervisorIdeaStartPage.class));

        long id = pp.get(PageParameterKeys.MAP.get(ApplicationPeriod.class)).toLong();
        IModel<ApplicationPeriod> applicationPeriod = new DetachableServiceModel<>(applicationPeriodService, id);
        add(new SupervisorAllSelectableStudentIdeasPanel("ideaPanel", applicationPeriod));
    }
}
