package se.su.dsv.scipro.milestones.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAuthorMyProjects;
import se.su.dsv.scipro.milestones.panels.MileStoneOverviewPanel;
import se.su.dsv.scipro.project.pages.AbstractProjectDetailsPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.ProjectModule;

@Authorization(authorizedRoles = { Roles.AUTHOR})
@ProjectModuleComponent(ProjectModule.MILESTONES)
public class ProjectMileStonePage extends AbstractProjectDetailsPage implements MenuHighlightAuthorMyProjects {

    public ProjectMileStonePage(PageParameters pp) {
        super(pp);

        add(new MileStoneOverviewPanel(OVERVIEW_PANEL, projectModel));
    }

    static final String OVERVIEW_PANEL = "overviewPanel";
}
