package se.su.dsv.scipro.notifications;

import org.apache.wicket.Component;
import org.apache.wicket.resource.loader.IStringResourceLoader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import se.su.dsv.scipro.util.PropsUtils;

import java.util.Locale;
import java.util.Properties;


public class NotificationLoader implements IStringResourceLoader {
    private static final Logger LOGGER = LoggerFactory.getLogger(NotificationLoader.class);

    @Override
    public String loadStringResource(Class<?> clazz, String key, Locale locale, String style, String variation) {
        return getKeywordString(key);
    }

    @Override
    public String loadStringResource(Component component, String key, Locale locale, String style, String variation) {
        return getKeywordString(key);
    }

    private String getKeywordString(String key) {
        String keyWord = null;
        try {
            Properties p = PropsUtils.load("se/su/dsv/scipro/notifications/notifications.properties");
            keyWord = p.getProperty(key);
        } catch (Exception e) {
            LOGGER.error("Could not get property", e);
        }
        return keyWord;
    }
}