package se.su.dsv.scipro.notifications.settings.panels;

import org.apache.wicket.markup.html.panel.Panel;
import se.su.dsv.scipro.data.dataobjects.Member;
import se.su.dsv.scipro.notifications.dataobject.*;

import java.util.Arrays;
import java.util.List;

public class ReceiverConfigurationPanel extends Panel {

    public ReceiverConfigurationPanel(String id) {
        super(id);

        add(new AbstractReceiverConfigurationPanel(PROJECT_RECEIVERS, Notification.Type.PROJECT, ProjectEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.SUPERVISOR, Member.Type.CO_SUPERVISOR, Member.Type.REVIEWER, Member.Type.AUTHOR);
            }
        });
        add(new AbstractReceiverConfigurationPanel(FORUM_RECEIVERS, Notification.Type.FORUM, ProjectForumEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.SUPERVISOR, Member.Type.CO_SUPERVISOR, Member.Type.REVIEWER, Member.Type.AUTHOR);
            }
        });
        add(new AbstractReceiverConfigurationPanel(SEMINAR_RECEIVERS, Notification.Type.FINAL_SEMINAR, SeminarEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.SUPERVISOR, Member.Type.CO_SUPERVISOR, Member.Type.REVIEWER, Member.Type.AUTHOR, Member.Type.OPPONENT, Member.Type.ACTIVE_PARTICIPANT);
            }
        });
        add(new AbstractReceiverConfigurationPanel(IDEA_RECEIVERS, Notification.Type.IDEA, IdeaEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.CREATOR, Member.Type.CO_AUTHOR, Member.Type.SUPERVISOR);
            }
        });
        add(new AbstractReceiverConfigurationPanel(PEER_RECEIVERS, Notification.Type.PEER, PeerEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.AUTHOR, Member.Type.SUPERVISOR, Member.Type.REVIEWER, Member.Type.CO_SUPERVISOR, Member.Type.PEER_REQUESTER, Member.Type.PEER_REVIEWER);
            }
        });
        add(new AbstractReceiverConfigurationPanel(MILESTONE_RECEIVERS, Notification.Type.MILESTONE, MileStoneEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.MILESTONE_INDIVIDUAL);
            }
        });
        add(new AbstractReceiverConfigurationPanel(GROUP_RECEIVERS, Notification.Type.GROUP, GroupEvent.Event.values()) {
            @Override
            protected List<Member.Type> getMemberTypes() {
                return Arrays.asList(Member.Type.SUPERVISOR, Member.Type.CO_SUPERVISOR, Member.Type.REVIEWER, Member.Type.AUTHOR);
            }
        });
    }

    static final String PROJECT_RECEIVERS = "projectReceivers";
    static final String FORUM_RECEIVERS = "forumReceivers";
    static final String SEMINAR_RECEIVERS = "seminarReceivers";
    static final String IDEA_RECEIVERS = "ideaReceivers";
    static final String PEER_RECEIVERS = "peerReceivers";
    static final String MILESTONE_RECEIVERS = "mileStoneReceivers";
    static final String GROUP_RECEIVERS = "groupReceivers";

}