package se.su.dsv.scipro.peer;

import org.apache.wicket.Page;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.admin.panels.PeerRequestStatsPanel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.statistics.AbstractAdminStatisticsPage;

import java.util.Collections;

@Authorization(authorizedRoles = { Roles.ADMIN })
public class AdminPeersPage extends AbstractAdminStatisticsPage {

    public AdminPeersPage() {
        add(new PeerReviewStatisticsPanel("peerReviewList", new PeerReviewStatisticsPanel.PageSupplier() {
            @Override
            public Page statusPage(IModel<PeerReview.ReviewStatus> model, PeerReviewService.Filter filter) {
                filter.setStatuses(Collections.singletonList(model.getObject()));
                return new AdminPeerReviewStatusStatisticsPage(filter);
            }

            @Override
            public Page chartPage(PeerReviewService.Filter filter) {
                return new AdminPeerReviewChartPage(filter);
            }
        }));
        add(new PeerRequestStatsPanel("peerRequestStats"));
        add(new PeerRequestListPanel("peerRequestList"));
	}
}
