package se.su.dsv.scipro.profile;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.match.IdeaParticipation;
import se.su.dsv.scipro.system.Program;
import se.su.dsv.scipro.system.User;

public class StudentProfileProgramPanel extends Panel {
    public StudentProfileProgramPanel(String id, IModel<IdeaParticipation> model, boolean shorten) {
        super(id, model);
        add(new UserLinkPanel(USER, new PropertyModel<User>(model, "user")));
        Program program = model.getObject().getProgram();
        add(new Label(PROGRAM, program != null ? shorten ? program.getCode() : program.getName() : ""));
    }

    public static final String USER = "user";
    public static final String PROGRAM = "program";
}
