package se.su.dsv.scipro.profile;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.components.ModalWindowPlus;
import se.su.dsv.scipro.system.User;

public class UserLinkPanel extends GenericPanel<User> {

    private ModalWindowPlus modalWindowPlus;

    public UserLinkPanel(String id) {
        super(id);
    }

    public UserLinkPanel(String id, final IModel<User> model) {
        super(id, model);
    }

    @Override
    protected void onInitialize() {
        super.onInitialize();

        modalWindowPlus = new ModalWindowPlus(DIALOG);
        add(modalWindowPlus);

        add(new UserProfileImage("gravatar", getModel(), UserProfileImage.Size.TINY));

        AjaxLink<User> link = new AjaxLink<User>(DIALOGLINK, getModel()) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                modalWindowPlus.setTitle("Profile for " + getModelObject().getFullName());
                modalWindowPlus.setContent(new DisplayUserProfilePanel(modalWindowPlus.getContentId(), getModel()));
                modalWindowPlus.show(target);
            }
        };

        link.add(new UserLabel(NAME, getModel()));
        add(link);
    }

    @Override
    protected void onConfigure() {
        super.onConfigure();
        setVisibilityAllowed(getDefaultModelObject() != null);
    }
    public static final String DIALOGLINK = "dialoglink";
    public static final String NAME = "name";
    public static final String DIALOG = "modalWindowPlus";
    public static final String CONTENT = "body";
    public static final String MAILLINK = "maillink";

}
