package se.su.dsv.scipro.project.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyProjects;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.panels.SupervisorEditProjectPanel;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorProjectDetailsPage;
import se.su.dsv.scipro.system.User;

public class SupervisorEditProjectPage extends AbstractSupervisorProjectDetailsPage implements MenuHighlightSupervisorMyProjects {

	public SupervisorEditProjectPage(PageParameters pp) {
		super(pp);
		redirectToHomePageIfUserIsNotSupervisor();
		add(new SupervisorEditProjectPanel("editProjectPanel", projectModel));
	}

	private void redirectToHomePageIfUserIsNotSupervisor() {
		Project project = projectModel.getObject();
		User headSupervisor = project.getHeadSupervisor();
		User user = SciProSession.get().getUser();
		if (!headSupervisor.equals(user)) {
			setResponsePage(getApplication().getHomePage());
		}
	}
}
