package se.su.dsv.scipro.reviewer.timeline;

import org.apache.wicket.markup.html.basic.EnumLabel;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import scala.Option;
import se.su.dsv.scipro.components.DateLabel;
import se.su.dsv.scipro.components.NullableOptionModel;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.profile.UserLinkPanel;
import se.su.dsv.scipro.repository.panels.ViewAttachmentPanel;
import se.su.dsv.scipro.reviewing.Decision;
import se.su.dsv.scipro.reviewing.ReviewerApproval;
import se.su.dsv.scipro.system.User;

import java.util.Date;

class ApprovedPanel extends Panel {
    public ApprovedPanel(final String id, final IModel<Decision> decision) {
        super(id);
        add(new EnumLabel<>("topic", new PropertyModel<ReviewerApproval.Step>(decision, "reviewerApproval.step")));
        add(new DateLabel("when", new PropertyModel<Date>(decision, "decisionDate"), DateStyle.DATETIME));
        add(new UserLinkPanel("reviewer", new PropertyModel<User>(decision, "reviewerApproval.project.reviewer")));
        add(new Label("message", new PropertyModel<String>(decision, "reason")));
        add(new ViewAttachmentPanel("attachment", new NullableOptionModel<>(new PropertyModel<Option<FileDescription>>(decision, "attachment"))));
        add(new ViewAttachmentPanel("gradingReport", new NullableOptionModel<>(new PropertyModel<Option<FileDescription>>(decision, "gradingReport"))));
    }
}
