package se.su.dsv.scipro.rwandagrading;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.model.PropertyModel;
import scala.Option;
import se.su.dsv.scipro.components.DateLabel;
import se.su.dsv.scipro.components.NullableOptionModel;
import se.su.dsv.scipro.grading.Grade;
import se.su.dsv.scipro.grading.GradeService;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.system.ProjectModule;

import javax.inject.Inject;
import java.util.Date;

@ProjectModuleComponent(ProjectModule.FINAL_GRADING)
public class DisplayGradePanel extends GenericPanel<Project> {
    @Inject
    private GradeService gradeService;

    public DisplayGradePanel(final String id, final IModel<Project> model) {
        super(id, model);
        IModel<Grade> gradeModel = new NullableOptionModel<>(new LoadableDetachableModel<Option<Grade>>() {
            @Override
            protected Option<Grade> load() {
                return gradeService.getGrade(model.getObject());
            }
        });
        add(new Label("grade", new PropertyModel<>(gradeModel, "value")));
        add(new DateLabel("reportedOn", new PropertyModel<Date>(gradeModel, "reportedOn")) {
            @Override
            protected void onConfigure() {
                setVisible(getDefaultModelObject() != null);
            }
        });
    }
}
