package se.su.dsv.scipro.settings.pages;

import se.su.dsv.scipro.basepages.MenuPage;
import se.su.dsv.scipro.components.AbstractMenuPanel;
import se.su.dsv.scipro.notifications.pages.SupervisorNotificationSettingsPage;
import se.su.dsv.scipro.supervisor.pages.SupervisorProfilePage;

import java.util.ArrayList;
import java.util.List;

import static se.su.dsv.scipro.components.AbstractMenuPanel.MenuType.TAB_MULTIPLE_ROWS;


public abstract class AbstractSettingsPage extends MenuPage {

    public AbstractSettingsPage() {
        add(new AbstractMenuPanel("menuPanel", AbstractSettingsPage.class, this.getClass()) {

            @Override
            protected List<MenuItem> getItemList() {
                final List<MenuItem> items = new ArrayList<>();
                items.add(new MenuItem("Basic profile", BasicProfilePage.class));
                items.add(new MenuItem("Supervisor profile", SupervisorProfilePage.class));
                items.add(new MenuItem("Notification settings", SupervisorNotificationSettingsPage.class));
                return items;
            }

            @Override
            protected MenuType getMenuType() {
                return TAB_MULTIPLE_ROWS;
            }

        });
    }

}
