package se.su.dsv.scipro.user;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import se.su.dsv.scipro.components.UserAutoComplete;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.system.User;

@Authorization(authorizedRoles = {Roles.SYSADMIN})
public class AdminSwitchUserPage extends AbstractAdminUsersPage {

    public static final String FORM = "form";
    public static final String USER = "user";

    private IModel<User> userModel = new Model<>();

    public AdminSwitchUserPage() {
        add(new Form<Void>(FORM) {
            {
                add(new UserAutoComplete(USER, userModel));
            }

            @Override
            protected void onSubmit() {
                super.onSubmit();
                if (userModel.getObject() != null) {
                    SciProSession.get().setUser(userModel.getObject());
                    setResponsePage(getApplication().getHomePage());
                } else {
                    setResponsePage(getPage());
                }
            }
        });
    }

}
