package se.su.dsv.scipro.`match`

import javax.inject.Inject

import org.apache.wicket.markup.html.basic.Label
import org.apache.wicket.model.PropertyModel
import org.apache.wicket.request.mapper.parameter.PageParameters
import se.su.dsv.scipro.StringValueConversions
import se.su.dsv.scipro.`match`._
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightProjectMyIdeas
import se.su.dsv.scipro.data.DetachableServiceModel
import se.su.dsv.scipro.util.PageParameterKeys

import scala.collection.JavaConversions._

class ProjectIdeaDetailsPage(pp: PageParameters) extends AbstractIdeaProjectPage(pp) with MenuHighlightProjectMyIdeas {
  @Inject private var ideaService: IdeaService = _
  
  val idea = for {
    id ← pp.get(PageParameterKeys.MAP.get(classOf[Idea])).asLong
    idea ← Option(ideaService.findOne(id))
    if idea.getIdeaParticipations.map(_.getUser).contains(getUser)
  } yield new DetachableServiceModel(ideaService, idea)
 
  idea.fold(setResponsePage(getApplication.getHomePage)) { model ⇒
    add(new Label("title", new PropertyModel[String](model, "title")))
    add(new CompleteIdeaDialogPanel("idea", model))
  }
}