package se.su.dsv.scipro.notifications.pages

import org.apache.wicket.Page
import org.apache.wicket.request.mapper.parameter.PageParameters
import se.su.dsv.scipro.`match`.{ProjectIdeaStartPage, SupervisorIdeaStartPage, Idea}
import se.su.dsv.scipro.notifications.dataobject.IdeaEvent
import se.su.dsv.scipro.notifications.dataobject.IdeaEvent.Event
import se.su.dsv.scipro.system.User

private[pages] trait IdeaRedirection {
  import IdeaRedirection._

  def ideaLocation(event: IdeaEvent): UserBasedLocation = {
    val idea = event.getIdea

    val page: PartialFunction[User, Class[_ <: Page]] = {
      case user if idea.isSupervisor(user) => classOf[SupervisorIdeaStartPage]
      case user if idea.isAuthor(user) => classOf[ProjectIdeaStartPage]
    }
    val pp = new PageParameters
    pp.set(parameter[Idea], idea.getId)
    page andThen { (_, pp) }
  }
}

object IdeaRedirection {
  implicit class IdeaEnhancement(val idea: Idea) extends AnyVal {
    import scala.collection.JavaConverters.iterableAsScalaIterableConverter

    def isSupervisor(user: User) = Option(idea.getMatch).exists(_.getSupervisor == user)
    def isAuthor(user: User) = idea.getIdeaParticipations.asScala.exists(_.getUser == user)
  }
}