package se.su.dsv.scipro.notifications.pages

import org.apache.wicket.request.mapper.parameter.PageParameters
import se.su.dsv.scipro.notifications.dataobject.PeerEvent.Event
import se.su.dsv.scipro.notifications.dataobject.PeerRequestEvent
import se.su.dsv.scipro.peer.PeerPortalPage
import se.su.dsv.scipro.project.Project
import se.su.dsv.scipro.system.User

import scala.collection.JavaConverters.iterableAsScalaIterableConverter

private[pages] trait PeerRequestRedirection {
  def peerRequestLocation(event: PeerRequestEvent): UserBasedLocation = {
    def isPeerReviewer(user: User) = event.getRequest.getPeerReviews.asScala.exists(_.getReviewer == user)

    event.getEvent match {
      case Event.REQUEST_DELETED => {
        case user if isPeerReviewer(user) =>
          val pp = new PageParameters
          val peerReview = event.getRequest.getPeerReviews.asScala.find(_.getReviewer == user).get
          pp.set(parameter[Project], peerReview.getProject.getId)
          (classOf[PeerPortalPage], pp)
      }
      case Event.REQUEST_EXPIRED => {
        case user if event.getRequest.getRequester == user =>
          val pp = new PageParameters
          pp.set(parameter[Project], event.getRequest.getProject.getId)
          (classOf[PeerPortalPage], pp)
      }
      case _ => PartialFunction.empty
    }
  }
}
