package se.su.dsv.scipro.notifications.pages

import org.apache.wicket.request.mapper.parameter.PageParameters
import se.su.dsv.scipro.forum.pages.{ProjectForumBasePage, SupervisorForumBasePage}
import se.su.dsv.scipro.notifications.dataobject.ProjectForumEvent
import se.su.dsv.scipro.notifications.dataobject.ProjectForumEvent.Event
import se.su.dsv.scipro.project.Project
import se.su.dsv.scipro.reviewer.ReviewerInteractionPage
import se.su.dsv.scipro.supervisor.pages.SupervisorInteractWithReviewerPage

private[pages] trait ProjectForumRedirection {
  def projectForumLocation(event: ProjectForumEvent): UserBasedLocation = {
    val project = event.getProject

    val pp = new PageParameters
    pp.set(parameter[Project], project.getId)

    event.getEvent match {
      case Event.NEW_FORUM_POST | Event.NEW_FORUM_POST_COMMENT => {
        case user if project.isParticipant(user) => (classOf[ProjectForumBasePage], pp)
        case user if project.hasSupervisingRole(user) => (classOf[SupervisorForumBasePage], pp)
      }
      case Event.NEW_REVIEWER_INTERACTION => {
        case user if project.isSupervisor(user) => (classOf[SupervisorInteractWithReviewerPage], pp)
        case user if project.isReviewer(user) => (classOf[ReviewerInteractionPage], pp)
      }
    }
  }
}
