package se.su.dsv.scipro.notifications

import org.apache.wicket.Page
import org.apache.wicket.request.mapper.parameter.PageParameters
import se.su.dsv.scipro.project.Project
import se.su.dsv.scipro.system.User
import se.su.dsv.scipro.util.PageParameterKeys

import scala.reflect.ClassTag

package object pages {
  type UserBasedLocation = PartialFunction[User, (Class[_ <: Page], PageParameters)]

  def parameter[T](implicit $ev: ClassTag[T]): String = {
    PageParameterKeys.MAP.get($ev.runtimeClass)
  }

  implicit class ProjectEnhancement(val project: Project) extends AnyVal {
    def hasSupervisingRole(user: User) =
      project.isSupervisor(user) || project.isCoSupervisor(user) || project.isReviewer(user)
  }
}
