package se.su.dsv.scipro;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.junit.Test;
import se.su.dsv.scipro.security.auth.roles.Roles;

public abstract class PageTest extends SciProTest {

    @Test
    public void page_renders_when_logged_in() {
        setRoles(getRoles());
        setLoggedIn(true);

        startPage();
        tester.assertRenderedPage(getPage());
        tester.assertNoErrorMessage();
    }

    protected void startPage() {
        tester.startPage(getPage(), getPageParameters());
    }

    public Roles[] getRoles() {
        return Roles.values();
    }

    protected PageParameters getPageParameters() {
        return new PageParameters(null);
    }

    protected abstract Class<? extends Page> getPage();
}
