package se.su.dsv.scipro.activityplan;

import org.apache.wicket.model.Model;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static org.mockito.Matchers.*;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class AddActivitiesFromTemplatePanelTest extends SciProTest {

    private List<ActivityPlanTemplate> templates;
    private Project project;

    @Before
    public void setUp() throws Exception {
        ActivityPlanTemplate template1 = new ActivityPlanTemplate();
        template1.setId(8L);
        User creator = new User();
        creator.setEmailAddress("example@example.com");
        template1.setCreator(creator);
        ActivityPlanTemplate template2 = new ActivityPlanTemplate();
        template2.setId(98L);
        template2.setCreator(creator);

        templates = Arrays.asList(template1, template2);
        project = new Project();

        when(activityPlanTemplateService.findAll(isA(ActivityPlanTemplateService.Filter.class)))
                .thenReturn(templates);
        tester.startComponentInPage(new AddActivitiesFromTemplatePanel("id", Model.of(project)));
    }

    @Test
    public void lists_all_templates() throws Exception {
        tester.assertListView(path("id", "content", "stupidContainerSinceWicketCantRefreshListViews", "templates"), templates);
    }

    @Test
    public void add_activities_from_template() throws Exception {
        tester.clickLink(path("id", "content", "stupidContainerSinceWicketCantRefreshListViews", "templates", 0, "title"), true);
        FormTester formTester = tester.newFormTester(path("id", "content", "form"));
        formTester.submit();
        verify(activityPlanFacade).addActivitiesFromTemplate(eq(project), eq(templates.get(0)), any(Date.class));
    }
}