package se.su.dsv.scipro.activityplan;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.checklist.ChecklistTemplate;

import java.util.Collections;

import static se.su.dsv.scipro.activityplan.AdminEditActivityPanel.*;

public class AdminEditActivityPanelTest extends SciProTest{

    private AdminEditActivityPanel panel;

    @Before
    public void setUp() throws Exception {
        ChecklistTemplate checklistTemplate = new ChecklistTemplate();
        checklistTemplate.setId(1L);
        checklistTemplate.setName("template");
        Mockito.when(checklistTemplateService.findAll()).thenReturn(Collections.singletonList(checklistTemplate));
        startPanel();
    }

    @Test
    public void title_required() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), FORM));
        formTester.setValue(DAYS_FIELD, "10");
        formTester.submit();
        tester.assertErrorMessages("Title cannot be left blank");
    }

    @Test
    public void days_required() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), FORM));
        formTester.setValue(TITLE_FIELD, "a nice title");
        formTester.setValue(DAYS_FIELD, "");
        formTester.submit();
        tester.assertErrorMessages("Days offset cannot be left blank");
    }

    @Test
    public void submits() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), FORM));
        formTester.setValue(TITLE_FIELD, "a nice title");
        formTester.setValue(DAYS_FIELD, "10");
        formTester.submit();
        tester.assertNoErrorMessage();
    }

    private void startPanel() {
        panel = tester.startComponentInPage(new AdminEditActivityPanel("panel", new Model<>(new ActivityTemplate())) {
            @Override
            protected void onSubmit(final AjaxRequestTarget target, final IModel<ActivityTemplate> activity) {
            }
        });
    }
}
