package se.su.dsv.scipro.admin.pages.settings;

import org.apache.wicket.Page;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.plagiarism.TurnitinSettings;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class TurnitinSettingsPageTest extends PageTest {

    TurnitinSettingsPage page;

    @Before
    public void setUp() throws Exception {
        when(turnitinSettingsService.getSettings()).thenReturn(new TurnitinSettings());
        page = tester.startPage(TurnitinSettingsPage.class);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return TurnitinSettingsPage.class;
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester(TurnitinSettingsPage.SETTINGS);
        formTester.setValue("username", "thesissupport@dsv.su.se");
        formTester.setValue("password", "qwerty");
        formTester.setValue("firstName", "Thesis");
        formTester.setValue("lastName", "Support");
        formTester.setValue("className", "Stallone studies");
        formTester.setValue("assignmentName", "NameAStalloneMovie");
        formTester.setValue("sharedKey", "12345");
        formTester.setValue("integrationURL", "https://api.turnitin.com/");
        formTester.setValue("integrationId", "1");
        formTester.submit();
        tester.assertNoErrorMessage();
        tester.assertInfoMessages("Settings saved");
        verify(turnitinSettingsService).save(isA(TurnitinSettings.class));
    }
}
