package se.su.dsv.scipro.applicationperiod;

import org.junit.Before;
import org.junit.Test;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.match.ApplicationPeriod;

import java.util.*;

import static org.mockito.Matchers.any;
import static org.mockito.Mockito.when;

public class AdminApplicationPeriodsPanelTest extends SciProTest {

    @Before
    public void setUp() throws Exception {
        ApplicationPeriod applicationPeriod = new ApplicationPeriod("VT14");
        applicationPeriod.setStartDate(new Date(0));
        applicationPeriod.setEndDate(new Date(86400));
        applicationPeriod.setCourseStartDate(new Date(86400 * 2));
        List<ApplicationPeriod> applicationPeriods = new ArrayList<>(Collections.singletonList(applicationPeriod));
        when(applicationPeriodService.count()).thenReturn( (long) applicationPeriods.size());
        when(applicationPeriodService.findAll(any(Pageable.class))).thenReturn(applicationPeriods);
    }

    @Test
    public void renders() throws Exception {
        tester.startComponentInPage(AdminApplicationPeriodsPanel.class);
    }
}
