package se.su.dsv.scipro.components;

import org.apache.wicket.extensions.markup.html.basic.SmartLinkMultiLineLabel;
import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;

import static se.su.dsv.scipro.components.InfoPanel.*;

public class InfoPanelTest extends SciProTest {

    private InfoPanel panel;

    @Before
    public void setUp() throws Exception {
        startPanel();
    }

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    @Test
    public void info_invisible_before_click() throws Exception {
        tester.assertInvisible(path(panel, CONTAINER, INFO));
    }

    @Test
    public void info_visible_after_click() throws Exception {
        tester.clickLink(path(panel, CONTAINER, SHOW));
        tester.assertComponent(path(panel, CONTAINER, INFO), SmartLinkMultiLineLabel.class);
    }

    private void startPanel(){
        panel = tester.startComponentInPage(new InfoPanel("id", Model.of("bla bla")));
    }
}
