package se.su.dsv.scipro.finalseminar;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.junit.Before;
import org.mockito.Matchers;
import org.mockito.Mockito;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.DomainObjects;
import se.su.dsv.scipro.test.UserBuilder;
import se.su.dsv.scipro.util.PageParameterKeys;

import java.util.Arrays;
import java.util.Collections;
import java.util.TreeSet;

public class ProjectFinalSeminarPageTest extends PageTest {

    ProjectFinalSeminarPage page;
    Project project;

    @Before
    public void setUp() throws Exception {
        User student = new UserBuilder().setFirstName("author").setLastName("1").create();
        User supervisor = new UserBuilder().setFirstName("head").setLastName("supervisor").create();
        project = Project.builder()
                .title("some title")
                .projectType(new ProjectType(DegreeLevel.FIRST_CYCLE, "Bachelor", "Bachelor"))
                .headSupervisor(supervisor)
                .build();
        DomainObjects.injectId(project, 1L);

        Mockito.when(projectService.findOne(Matchers.isA(Long.class))).thenReturn(project);
        Mockito.when(projectService.isPartOfProject(Matchers.isA(Project.class), Matchers.isA(User.class))).thenReturn(true);

        page = tester.startPage(ProjectFinalSeminarPage.class, getPageParameters());
    }

    @Override
    protected Class<? extends Page> getPage() {
        return ProjectFinalSeminarPage.class;  //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    protected PageParameters getPageParameters() {
        PageParameters pageParameters = new PageParameters();
        pageParameters.add(PageParameterKeys.MAP.get(Project.class), 1);
        return pageParameters;
    }
}
