package se.su.dsv.scipro.firstmeeting;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.match.IdeaParticipation;
import se.su.dsv.scipro.system.User;

public class FirstMeetingColumnPanelTest extends SciProTest {

    private Idea idea;

    @Before
    public void setUp() throws Exception {
        User kalle = User.builder().firstName("Kalle").lastName("Testare").emailAddress("kalle@test.com").build();
        User fnatte = User.builder().firstName("Fnatte").lastName("Testare").emailAddress("fnatte@test.com").build();

        idea = new Idea();
        idea.setType(Idea.Type.STUDENT);
        idea.addIdeaParticipation(new IdeaParticipation(kalle, idea));
        idea.addIdeaParticipation(new IdeaParticipation(fnatte, idea));
    }

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    private void startPanel() {
        tester.startComponentInPage(new FirstMeetingColumnPanel("id", Model.of(idea)) {
            @Override
            protected void onColumnClick(AjaxRequestTarget target, IModel<Idea> model) {
            }
        });
    }
}
