package se.su.dsv.scipro.match;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.test.ObjectMother;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.when;

public class AdminIdeaDetailsPanelTest extends SciProTest {

    @Before
    public void setUp() throws Exception {
        when(ideaService.findOne(isA(Long.class))).thenReturn(new Idea());
    }

    @Test
    public void renders() throws Exception {
        tester.startComponentInPage(new AdminIdeaDetailsPanel("id", Model.of(idea()), new WebMarkupContainer("wmc")) {
            @Override
            public void update(AjaxRequestTarget target) {
            }
        });
    }

    private Idea idea() {
        Idea idea = new ObjectMother.IdeaBuilder().create();
        idea.setType(Idea.Type.SUPERVISOR);
        return idea;
    }
}
