package se.su.dsv.scipro.match;

import org.apache.wicket.Component;
import org.apache.wicket.ajax.form.AjaxFormChoiceComponentUpdatingBehavior;
import org.apache.wicket.behavior.AbstractAjaxBehavior;
import org.apache.wicket.behavior.Behavior;
import org.apache.wicket.util.tester.WicketTesterHelper;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Matchers;
import org.mockito.Mockito;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.components.ExportableDataPanel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class AdminIdeaStatisticsPageTest extends SciProTest {

    @Before
    public void startPage() throws Exception {
        Mockito.when(applicationPeriodService.findAll(Matchers.any(Pageable.class))).thenReturn(createPage());
        Mockito.when(applicationPeriodService.count()).thenReturn(1L);
        tester.startPage(AdminIdeaStatisticsPage.class);
    }

    @Test
    public void renders() throws Exception {
        tester.assertRenderedPage(AdminIdeaStatisticsPage.class);
    }

    @Test
    public void testPageContainsDataTable() throws Exception {
        tester.assertComponent(AdminIdeaStatisticsPage.TABLE, ExportableDataPanel.class);
    }

    @Test
    public void changing_filter_updates_table() throws Exception {
        Behavior behavior = WicketTesterHelper.findBehavior(getStatusCheckbox(), AjaxFormChoiceComponentUpdatingBehavior.class);
        tester.executeBehavior((AbstractAjaxBehavior) behavior);
        tester.assertComponentOnAjaxResponse(path(AdminIdeaStatisticsPage.TABLE));
    }

    private Component getStatusCheckbox() {
        return tester.getComponentFromLastRenderedPage(path(AdminIdeaStatisticsPage.STATUS_FILTER));
    }

    private List<ApplicationPeriod> createPage() {
        return Collections.singletonList(new ApplicationPeriod());
    }
}
