package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import se.su.dsv.scipro.SciProTest;

/**
 * @author : emil-siv
 * Date: 2013-07-03
 */
public class AdminKeywordSwitchPanelTest extends SciProTest {

    AdminKeywordSwitchPanel panel;
    @Mock
    FeedbackPanel feedbackPanel;

    @Before
    public void setUp() throws Exception {
        startPanel();
    }

    @Test
    public void testRenders() throws Exception {
        Assert.assertNotNull(panel);
    }

    @Test
    public void testPanelContainsSwitchPanel() throws Exception {
        tester.assertComponent(path(panel.getId(), AdminKeywordSwitchPanel.PANEL), AdminKeywordCrudPanel.class);
    }

    @Test
    public void testSwitchPanelShouldChangeOnLinkClick() throws Exception {
        tester.clickLink(path(panel.getId(), AdminKeywordSwitchPanel.AREA_LINK));
        tester.assertComponent(path(panel.getId(), AdminKeywordSwitchPanel.PANEL), AdminResearchAreaCrudPanel.class);

        tester.clickLink(path(panel.getId(), AdminKeywordSwitchPanel.KEYWORD_LINK));
        tester.assertComponent(path(panel.getId(), AdminKeywordSwitchPanel.PANEL), AdminKeywordCrudPanel.class);
    }

    @Test
    public void testKeywordLinkIsNotEnabledWhenEnteringPage() throws Exception {
        boolean keywordEnabled = panel.get(AdminKeywordSwitchPanel.KEYWORD_LINK).isEnabledInHierarchy();
        Assert.assertFalse(keywordEnabled);
    }

    @Test
    public void testAreaLinkIsNotEnabledAfterClick() throws Exception {
        boolean areaEnabled = panel.get(AdminKeywordSwitchPanel.AREA_LINK).isEnabledInHierarchy();
        Assert.assertTrue(areaEnabled);

        tester.clickLink(path(panel.getId(), AdminKeywordSwitchPanel.AREA_LINK));

        boolean areaEnabledAfterClick = panel.get(AdminKeywordSwitchPanel.AREA_LINK).isEnabledInHierarchy();
        Assert.assertFalse(areaEnabledAfterClick);
    }

    private void startPanel() {
        panel = tester.startComponentInPage(new AdminKeywordSwitchPanel("panel"));
    }
}
