package se.su.dsv.scipro.match;

import org.apache.wicket.Page;
import org.junit.Before;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.system.Program;

import java.util.Arrays;
import java.util.Collections;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.when;

public class AdminProgramPageTest extends PageTest {

    AdminProgramPage page;

    @Before
    public void setUp() throws Exception {

        Program program = new Program();
        program.setName("Super program");
        program.setNameEn("Super program");
        program.setCode("sp");
        program.setId(1L);

        when(programService.findAll(isA(Pageable.class))).thenReturn(Collections.singletonList(program));
        when(programService.count()).thenReturn(1L);
        when(programService.findOne(isA(Long.class))).thenReturn(program);
        page = tester.startPage(AdminProgramPage.class);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return AdminProgramPage.class;
    }
    
}