package se.su.dsv.scipro.match;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.ResearchArea;

import java.util.Arrays;
import java.util.Collections;

import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class AdminResearchAreaEditPanelTest extends SciProTest{

    private ResearchArea area;
    private Keyword keyword;

    @Before
    public void setUp() throws Exception {
        area = new ResearchArea();
        keyword = new Keyword("k");
        when(keywordService.findByResearchArea(area))
                .thenReturn(Collections.singletonList(keyword));
    }

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    @Test
    public void remove_relationship_link_works() throws Exception {
        startPanel();
        tester.clickLink(path("id", "container", "listView", "0","removeLink"));
        verify(keywordService).deleteConnection(keyword, area);
    }

    private void startPanel() {
        tester.startComponentInPage(new AdminResearchAreaEditPanel("id", Model.of(area)) {
            @Override
            protected void updateTarget(AjaxRequestTarget target) {
                //do something
            }
        });
    }

}
