package se.su.dsv.scipro.match;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.Model;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.ResearchArea;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class EditResearchAreaPanelTest extends SciProTest {

    EditResearchAreaPanel panel;
    ResearchArea researchArea;

    @Before
    public void setUp() throws Exception {
        researchArea = new ResearchArea();
        researchArea.setId(1L);
        when(researchAreaService.save(isA(ResearchArea.class))).thenReturn(researchArea);
        startPanel();
    }

    @Test
    public void must_enter_research_area() throws Exception {
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertErrorMessages("'researchArea' is required.");
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), "form"));
        formTester.setValue(path("wmc", "researchArea"), "nice research area");
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertInfoMessages("Saved");
        verify(researchAreaService).save(isA(ResearchArea.class));
    }

    private void startPanel() throws Exception {
        panel = tester.startComponentInPage(new EditResearchAreaPanel("id", Model.of(researchArea)) {
            @Override
            public void onSave(AjaxRequestTarget target) {

            }
        });
    }
}