package se.su.dsv.scipro.match;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.Model;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.Unit;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class EditUnitPanelTest extends SciProTest {

    EditUnitPanel panel;
    Unit unit;

    @Before
    public void setUp() throws Exception {
        unit = new Unit();
        unit.setId(1L);
        when(unitService.save(isA(Unit.class))).thenReturn(unit);
        startPanel();
    }

    @Test
    public void must_enter_unit() throws Exception {
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertErrorMessages("'unit' is required.");
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), "form"));
        formTester.setValue(path("wmc", "unit"), "nice unit");
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertInfoMessages("Saved");
        verify(unitService).save(isA(Unit.class));
    }

    private void startPanel() throws Exception {
        panel = tester.startComponentInPage(new EditUnitPanel("id", Model.of(unit)) {
            @Override
            public void onSave(AjaxRequestTarget target) {

            }
        });
    }
}