package se.su.dsv.scipro.match;

import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.ResearchArea;
import se.su.dsv.scipro.test.ObjectMother;

public class IdeaDownloadPanelTest extends SciProTest {

    private IdeaDownloadPanel panel;
    private Idea idea;

    @Before
    public void setUp() throws Exception {
        createIdea();
        renderPanel();
    }

    private void createIdea() {
        idea = new ObjectMother.IdeaBuilder().setId(1L).setTitle("some title").create();
        idea.setResearchArea(new ResearchArea());
    }

    private void renderPanel() {
        panel = tester.startComponentInPage(new IdeaDownloadPanel("panel", Model.of(idea)));
    }

    @Test
    public void panel_rendered() {
        assert panel != null : "Could not render panel";
    }

}