package se.su.dsv.scipro.match;

import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.Language;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.ResearchArea;

import java.util.Collections;
import java.util.Date;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.when;

public class SupervisorIdeaDetailsPanelTest extends SciProTest {

    SupervisorIdeaDetailsPanel panel;
    Idea idea;

    @Before
    public void setUp() {
        Language english = new Language();
        english.setName("English");
        idea = new Idea();
        idea.setId(1L);
        Match match = new Match();
        match.setStatus(Idea.Status.MATCHED);
        idea.setMatch(match);
        idea.setType(Idea.Type.STUDENT);
        idea.setProjectType(new ProjectType(DegreeLevel.FIRST_CYCLE, "Bachelor", "Bachelor"));
        idea.setLanguages(Collections.singleton(english));
        idea.setResearchArea(new ResearchArea());
        ApplicationPeriod applicationPeriod = new ApplicationPeriod();
        applicationPeriod.setCourseStartDate(new Date());
        idea.setApplicationPeriod(applicationPeriod);
        when(ideaService.findOne(isA(Long.class))).thenReturn(idea);
        panel = tester.startComponentInPage(new SupervisorIdeaDetailsPanel("panel", Model.of(idea)));
    }

    @Test
    public void testRenders() {
        tester.assertNoErrorMessage();
    }
}
