package se.su.dsv.scipro.milestones.panels;

import org.apache.wicket.model.Model;
import org.joda.time.DateTime;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;

import java.util.ArrayList;
import java.util.List;

import static org.mockito.Matchers.eq;
import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.when;

public class MilestoneProgressPanelTest extends SciProTest {

    MileStoneProgressPanel panel;
    private Project project;

    @Before
    public void setUp() throws Exception {
        project = new Project();
        project.setDateCreated(new DateTime().minusDays(1).toDate());
        project.setProjectType(new ProjectType(DegreeLevel.FIRST_CYCLE, "Bachelor", "Bachelor"));
        when(milestoneActivityTemplateService.getActivities(isA(MilestoneActivityTemplate.Type.class), eq(project.getProjectType()), eq(project.getDateCreated()))).thenReturn(activityList(5));
        startPanel();
    }

    @Test
    public void testRenders() throws Exception {
        assert panel != null;
    }

    private List<MilestoneActivityTemplate> activityList(int count) {
        List<MilestoneActivityTemplate> list = new ArrayList<>();
        for (int i = 0; i < count; i++) {
            list.add(new MilestoneActivityTemplate());
        }
        return list;
    }

    private void startPanel() {
        panel = tester.startComponentInPage(new MileStoneProgressPanel("panel", Model.of(3L), MilestoneActivityTemplate.Type.PROJECT, Model.of(project)));
    }
}
