package se.su.dsv.scipro.notes;

import org.apache.wicket.feedback.FeedbackMessage;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.User;

import static org.junit.Assert.assertFalse;
import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class NotesPageTest extends SciProTest {

    @Before
    public void setUp() throws Exception {
        User user = User.builder().firstName("John").lastName("Rambo").emailAddress("rambo@gov.us").build();
        Note note = new Note();
        note.setUser(user);
        when(noteService.getNote(isA(User.class))).thenReturn(note);
        startPage();
    }

    private void startPage() {
        tester.startPage(NotesPage.class);
    }

    @Test
    public void renders() throws Exception {
        tester.assertRenderedPage(NotesPage.class);
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester("form");
        formTester.setValue("content", "bla bla");
        formTester.submit();
        tester.assertNoErrorMessage();
        assertFalse(tester.getMessages(FeedbackMessage.SUCCESS).isEmpty());
        verify(noteService).save(isA(Note.class));
    }

}