package se.su.dsv.scipro.phd;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.junit.Before;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.ObjectMother;
import se.su.dsv.scipro.util.PageParameterKeys;

import static org.mockito.Matchers.any;
import static org.mockito.Matchers.anyLong;
import static org.mockito.Mockito.when;

public class ProjectAdminPageTest extends PageTest {

    @Before
    public void setUp() throws Exception {
        when(projectService.findOne(anyLong())).thenReturn(ObjectMother.SOME_PROJECT);
        when(projectService.isPartOfProject(any(Project.class), any(User.class))).thenReturn(true);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return ProjectAdminPage.class;
    }

    @Override
    protected PageParameters getPageParameters() {
        PageParameters pageParameters = new PageParameters();
        pageParameters.set(PageParameterKeys.MAP.get(Project.class), 1L);
        return pageParameters;
    }
}
