package se.su.dsv.scipro.repository.components;

import org.apache.wicket.model.Model;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.file.FileDescription;

import static org.junit.Assert.assertFalse;

public class FileDownloadLinkTest extends SciProTest {

    public static final String SOME_FILE_NAME = "file.pdf";

    @Test
    public void render() throws Exception {
        renderLink();
    }

    @Test
    public void does_not_replace_body_with_file_name_by_default() throws Exception {
        renderLink();

        String markup = tester.getLastResponseAsString();
        assertFalse("Link body contains file name", markup.contains(SOME_FILE_NAME));
    }

    private void renderLink() {
        FileDescription fileDescription = new FileDescription();
        fileDescription.setName(SOME_FILE_NAME);
        fileDescription.setIdentifier("identifier");
        fileDescription.setId(1L);
        tester.startComponentInPage(new FileDownloadLink<>("id", Model.of(fileDescription)));
    }
}
